/* $Copyright$
 *  Copyright (C) Fujitsu Siemens Computers GmbH 2001, 2002
 *  All rights reserved
 */
#ident "$Header$"
#ifndef WITHOUT_INCLUDES
#ifndef __KERNEL__
#  define __KERNEL__
#endif
#ifndef MODULE_SUB
#  define MODULE
#endif
#ifndef PRECOMPILE
#include <linux/modversions.h>
#endif
#include <linux/module.h>
#include <linux/types.h>
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/slab.h>
#include <linux/mm.h>
#include <linux/string.h>
#include <linux/errno.h>
#include <linux/ioctl.h>
#include <linux/delay.h>
#include <linux/wrapper.h>
#include <linux/pci.h>
#include <asm/io.h>             /* inb_p */
#include <asm/uaccess.h>        /* put_user */
#include <linux/spinlock.h>
#include <asm/semaphore.h>
#include <linux/mc146818rtc.h>
#include <linux/pc_keyb.h>
#ifdef CALDERA
#ifndef LINUX_VERSION_CODE
#include <linux/version.h>
#endif
#endif
#if LINUX_VERSION_CODE >= 0x020400
#else
#include <linux/kcomp.h>
#define vm_pgoff                        vm_offset
#define virt_to_page                    MAP_NR
#endif
#endif
#ident "$Header: $"
#ident "$Header$"
#ident "$Header: $"
typedef char CHAR;
typedef short SHORT;
typedef int BOOL;
typedef int INT;
typedef long LONG;
typedef float FLOAT;
typedef double DOUBLE;
typedef long long LONGLONG;
typedef unsigned char BYTE;
typedef unsigned char UCHAR;
typedef unsigned short WORD;
typedef unsigned short USHORT;
typedef unsigned int DWORD;
typedef unsigned int UINT;
typedef unsigned long ULONG;
typedef unsigned long long DWORDLONG;
typedef unsigned long long QWORD;
typedef DWORD time_t32;
typedef void VOID;
typedef CHAR *PCHAR;
typedef SHORT *PSHORT;
typedef FLOAT *PFLOAT;
typedef DOUBLE *PDOUBLE;
typedef UCHAR *PUCHAR;
typedef USHORT *PUSHORT;
typedef UINT *PUINT;
typedef ULONG *PULONG;
typedef CHAR *PSZ;
typedef CHAR *LPSZ;
typedef CHAR *LPSTR;
typedef CHAR *LPTSTR;
typedef CHAR *LPCSTR;
typedef CHAR *LPCTSTR;
typedef BOOL *PBOOL;
typedef BOOL *LPBOOL;
typedef BYTE *PBYTE;
typedef BYTE *LPBYTE;
typedef INT *PINT;
typedef INT *LPINT;
typedef WORD *PWORD;
typedef WORD *LPWORD;
typedef LONG *PLONG;
typedef LONG *LPLONG;
typedef DWORD *PDWORD;
typedef DWORD *LPDWORD;
typedef DWORDLONG *PDWORDLONG;
typedef DWORDLONG *LPDWORDLONG;
typedef VOID *PVOID;
typedef VOID *LPVOID;
typedef VOID *LPCVOID;
#ident "$Header: snismdrv.h 1.2 99/12/22 $"
#ident "$Header: $"
#pragma pack(1)
typedef struct _DMI_20_HEADER
{
   UCHAR Type;
   UCHAR Length;
   USHORT Handle;
} DMI_20_HEADER, *LPDMI_20_HEADER;
typedef struct _DMI_20_HEADER_SUBTYPE
{
   UCHAR Type;
   UCHAR Length;
   USHORT Handle;
   UCHAR SubType;
} DMI_20_HEADER_SUBTYPE, *LPDMI_20_HEADER_SUBTYPE;
typedef struct _PHOENIX_DMI_TABLE_ENTRY
{
   USHORT Size;
   USHORT Handle;
   ULONG Procedure;
} PHOENIX_DMI_TABLE_ENTRY, *LPPHOENIX_DMI_TABLE_ENTRY;
typedef struct _PHOENIX_DMI_HEADER
{
   UCHAR Signature [10];
   UCHAR Revision;
   PHOENIX_DMI_TABLE_ENTRY Entry[1];
} PHOENIX_DMI_HEADER, *LPPHOENIX_DMI_HEADER;
typedef struct _DMI_IEPS
{
    UCHAR _DMI_Anchor_String[5];
    UCHAR IEPS_Checksum;
    USHORT SMBIOS_Struct_Table_Length;
    ULONG SMBIOS_Struct_Table_Addr;
    USHORT StructureNumber;
    UCHAR SMBIOS_BCD_Revision;
} DMI_IEPS, *LPDMI_IEPS;
typedef struct _DMI_21_EPS
{
   UCHAR _SM_Anchor_String[4];
   UCHAR EPS_Checksum;
   UCHAR EPS_Length;
   UCHAR SMBIOS_Major_Version;
   UCHAR SMBIOS_Minor_Version;
   USHORT StructureSizeMax;
   UCHAR EPS_Revision;
   UCHAR reserved[5];
   UCHAR _DMI_Anchor_String[5];
   UCHAR IEPS_Checksum;
   USHORT SMBIOS_Struct_Table_Length;
   ULONG SMBIOS_Struct_Table_Addr;
   USHORT StructureNumber;
   UCHAR SMBIOS_BCD_Revision;
} DMI_21_EPS, *LPDMI_21_EPS;
typedef struct BIOSInformation
{
   DMI_20_HEADER DmiHeader;
   BYTE vendor;
   BYTE version;
   USHORT startingAddress;
   BYTE releaseDate;
   BYTE romSize;
} BIOS_INFO, *PBIOS_INFO;
typedef struct BOARDInformation
{
   DMI_20_HEADER DmiHeader;
   BYTE MfgStrNr;
   BYTE ProdStrNr;
   BYTE VerStrNr;
   BYTE SerNumStrNr;
} BOARDINFO, *PBOARDINFO;
typedef struct sysEnclosure
{
   DMI_20_HEADER DmiHeader;
   BYTE manufacturer;
   BYTE type;
   BYTE version;
   BYTE serialNumber;
   BYTE assetTagNr;
   BYTE BootupState;
   BYTE PowerSupplyState;
   BYTE ThermalState;
   BYTE SecurityStatus;
   DWORD OEMDefined;
} SYS_ENCLOSURE, *PSYS_ENCLOSURE;
typedef struct processorInformation
{
   DMI_20_HEADER DmiHeader;
   BYTE socketDesignation;
   BYTE type;
   BYTE family;
   BYTE manufacturer;
   ULONG low_ID;
   ULONG high_ID;
   BYTE version;
   BYTE voltage;
   USHORT externalClock;
   USHORT maxSpeed;
   USHORT currentSpeed;
   BYTE status;
   BYTE upgrade;
} DMI_CPU_INFO, *PDMI_CPU_INFO;
typedef struct memModuleInformation
{
   DMI_20_HEADER DmiHeader;
   BYTE socketDesignation;
   BYTE bankConnections;
   BYTE currentSpeed;
   WORD memoryType;
   BYTE installedSize;
   BYTE enabledSize;
   BYTE errorStatus;
} MEMMODULE_INFO, *PMEMMODULE_INFO;
typedef struct cacheInformation
{
   DMI_20_HEADER DmiHeader;
   BYTE socketDesignation;
   WORD configuration;
   WORD maxSize;
   WORD installedSize;
   WORD supportedSRamType;
   WORD currentSRamType;
} CACHE_INFO, *PCACHE_INFO;
typedef struct memarrayInformation {
   DMI_20_HEADER DmiHeader;
   BYTE Location;
   BYTE Use;
   BYTE ErrorCorrection;
   DWORD MaxCapacity;
   WORD MemErrorInfoHandle;
   WORD NumberMemDevices;
} MEMARRAY_INFO, *PMEMARRAY_INFO;
typedef struct memdeviceInformation {
   DMI_20_HEADER DmiHeader;
   WORD MemArrayHandle;
   WORD MemErrorInfoHandle;
   WORD TotalWidth;
   WORD DataWidth;
   WORD DevSize;
   BYTE FormFactor;
   BYTE DeviceSet;
   BYTE DeviceLocator;
   BYTE BankLocator;
   BYTE MemType;
   WORD TypeDetail;
   WORD Speed;
   BYTE Manufacturer;
   BYTE SerialNumber;
   BYTE AssetTag;
   BYTE PartNumber;
} MEMDEVICE_INFO, *PMEMDEVICE_INFO;
typedef struct memmapaddrInformation {
   DMI_20_HEADER DmiHeader;
   DWORD StartAddress;
   DWORD EndAddress;
   WORD MemDeviceHandle;
   WORD MemArrayHandle;
   BYTE PartitionRowPosition;
   BYTE InterleavePosition;
   BYTE InterleaveDataDepth;
} MEMMAPADDR_INFO, *PMEMMAPADDR_INFO;
typedef struct IPMIInformation {
    DMI_20_HEADER DmiHeader;
    UCHAR InterfaceType;
    UCHAR IPMIRevision;
    UCHAR I2CAddress;
    UCHAR NVDevAddress;
    QWORD IO_BaseAddress;
    UCHAR BaseAddrModifier_IntInfo;
    UCHAR IntNumber;
} IPMI_INFO, *PIPMI_INFO;
typedef struct OMFboardId
{
   DMI_20_HEADER DmiHeader;
   USHORT boardHwConfig;
   union {
      ULONG boardId;
      struct {
         USHORT brdId;
         USHORT subId;
      } sId;
   } bId;
   USHORT boardHwGS;
   union {
      USHORT boardVariante;
      struct {
         BYTE WGS;
         BYTE BID;
      } wgs;
   } bVar;
   USHORT chassisId;
} OMF_BOARD_ID, *POMF_BOARD_ID;
typedef struct OMFBIOSId
{
   DMI_20_HEADER DmiHeader;
   ULONG OMFbiosId;
} OMF_BIOS_ID, *POMF_BIOS_ID;
typedef struct _SYSMON_DATA
{
    DMI_20_HEADER DmiHeader;
    BYTE SubType;
    BYTE HardwareId;
    BYTE AccessMethod[1];
} SYSMON_DATA, *LPSYSMON_DATA;
typedef struct BIOSIdentification
{
   DMI_20_HEADER DmiHeader;
   ULONG MagicBIOSIdentifier;
} BIOS_IDENTIFICATION, *PBIOS_IDENTIFICATION;
typedef struct _MEMMODULE_ADDONS
{
    DMI_20_HEADER DmiHeader;
    BYTE SubType;
    BYTE SubStruct[1];
} MEMMODULE_ADDONS, *LPMEMMODULE_ADDONS;
typedef struct sysBoardConfig
{
   DMI_20_HEADER DmiHeader;
   BYTE subType;
   BYTE nr_systemCabinetId;
   BYTE nr_manufactMonth;
   BYTE nr_systemPartNumber;
   BYTE nr_systemDescription;
   BYTE nr_systemBoardPartNummber;
   BYTE nr_systemBoardDescription;
   BYTE nr_systemBoardStep;
   BYTE nr_biosVersAndRev;
} SYSTEMBOARD_CONFIG, *PSYSTEMBOARD_CONFIG;
typedef struct _ANY_ACCESS_METHODE
{
   DMI_20_HEADER DmiHeader;
   UCHAR SubType;
   UCHAR HardwareId;
} ANY_ACCESS_METHODE, *LPANY_ACCESS_METHODE;
typedef struct _ACCESS_METHODE_TULIP
{
    ULONG StartAddressOfData;
    UCHAR MaxGPNVSize;
    UCHAR FeatureControlRegister;
    UCHAR Tulip45Reg;
    UCHAR Tulip49Reg;
    UCHAR Tulip4BReg;
} ACCESSMETHOD_TULIP, *LPACCESSMETHOD_TULIP;
typedef struct _ACCESSMETHOD_SIO
{
    ULONG StartAddressOfData;
    UCHAR MaxGPNVSize;
    UCHAR ANDMask;
    UCHAR ORMask;
    USHORT SIOIndexReg;
    USHORT SIODataReg;
} ACCESSMETHOD_SIO, *PACCESSMETHOD_SIO;
typedef struct _ACCESS_ERROR_LOG
{
    BYTE LogMedia;
    WORD OffsetInMedia;
    BYTE NrOfEntries;
    BYTE SizeOfLogEntry;
    BYTE TotalSize;
} ACCESS_ERROR_LOG, * LPACCESS_ERROR_LOG;
typedef struct _MUX_I2C_HEADER
{
    BYTE DeviceAddress;
    BYTE MuxChannel;
    BYTE NrChannel;
    BYTE RegisterIdx;
} MUX_I2C_HEADER , *LPMUX_I2C_HEADER;
typedef struct _CHL_MASK
{
    BYTE AndMask;
    BYTE OrMask;
} CHL_MASK, *LPCHL_MASK;
typedef struct _ACCESS_MUX_I2C
{
    MUX_I2C_HEADER MuxHeader;
    CHL_MASK ChlMask[1];
} ACCESS_MUX_I2C, * LPACCESS_MUX_I2C;
typedef struct _ACCESS_MUX_SMBUS
{
    BYTE DeviceId;
    BYTE DeviceAddress;
    BYTE MuxChannel;
} ACCESS_MUX_SMBUS, * LPACCESS_MUX_SMBUS;
typedef struct _ACCESS_MUX_ID_PROM
{
    BYTE IdPromClass;
    BYTE DeviceAddress;
    BYTE MuxChannel;
} ACCESS_MUX_ID_PROM, * LPACCESS_MUX_ID_PROM;
typedef union _ACCESS_ADDRESS
{
    struct
    {
        WORD IndexAddr;
        WORD DataAddr;
    } Io;
    DWORD PhysicalAddress32;
    WORD GPNVHandle;
} ACCESS_ADDRESS;
typedef struct _ACCESS_MEDIA
{
    BYTE Access;
    ACCESS_ADDRESS Address;
} ACCESS_MEDIA, *LPACCESS_MEDIA;
typedef struct _ACCESSMETHOD_PIIX_GPIO
{
    ULONG BitMask;
} ACCESSMETHOD_PIIX_GPIO, *PACCESSMETHOD_PIIX_GPIO;
typedef struct _ACCESSMETHOD_PIIX_GPIO_LOW
{
    ULONG BitMask;
} ACCESSMETHOD_PIIX_GPIO_LOW, *PACCESSMETHOD_PIIX_GPIO_LOW;
typedef struct _ACCESSMETHOD_PIIX_SMBUS
{
    UCHAR DeviceId;
    UCHAR DeviceAddress;
} ACCESSMETHOD_PIIX_SMBUS, *PACCESSMETHOD_PIIX_SMBUS;
typedef struct _ACCESSMETHOD_DMI_BIOS
{
    UCHAR Reserved1;
    UCHAR Reserved2;
} ACCESSMETHOD_DMI_BIOS, *PACCESSMETHOD_DMI_BIOS;
typedef struct _ACCESSMETHOD_EINSCHALTTIMER
{
    UCHAR Manufacturer;
} ACCESSMETHOD_EINSCHALTTIMER, *PACCESSMETHOD_EINSCHALTTIMER;
typedef struct _ACCESSMETHOD_NAUTILUS_ISA
{
    UCHAR IndexAddress;
    UCHAR DataAddress;
    ULONG Multiplier;
    ULONG Offset;
} ACCESSMETHOD_NAUTILUS_ISA, *PACCESSMETHOD_NAUTILUS_ISA;
typedef union _DEV_PAR
{
    DWORD EntityParam;
    struct _MUL_OFF
    {
        WORD Multiplier;
        WORD Offset;
    } EnCalc;
    struct _REF_VOLTAGE
    {
        WORD RefVoltage;
        WORD Fixed;
    } EnRefVolt;
    struct _FANS
    {
        UCHAR Minimum;
        UCHAR Maximum;
        UCHAR Percentage;
        UCHAR Ripple;
    } EnFan;
    struct _VOLT_LIMITS
    {
        UCHAR LimitMin;
        UCHAR Reserved1;
        UCHAR LimitMax;
        UCHAR Reserved2;
    } EnVolt;
    struct _THRESHOLD
    {
        WORD LowThresh;
        WORD HighThresh;
    } EnThreshold;
    struct _TEMP_LIMITS
    {
        UCHAR LowWarning;
        UCHAR LowCritical;
        UCHAR HighWarning;
        UCHAR HighCritical;
    } EnTemp;
} DEV_PAR, *PDEV_PAR;
typedef struct _ACCESSMETHOD_CALC
{
    UCHAR EntityId;
    DEV_PAR DevPar;
} ACCESSMETHOD_CALC, *PACCESSMETHOD_CALC;
typedef struct _ACCESS_METHOD
{
    union {
        ACCESSMETHOD_CALC Calc;
        ACCESSMETHOD_NAUTILUS_ISA Isa;
        ACCESSMETHOD_SIO Sio;
        ACCESSMETHOD_EINSCHALTTIMER PwrOn;
        ACCESSMETHOD_DMI_BIOS DmiBios;
        ACCESSMETHOD_PIIX_SMBUS SmBus;
        ACCESSMETHOD_PIIX_GPIO_LOW GpioLow;
        ACCESSMETHOD_PIIX_GPIO Gpio;
        ACCESS_MEDIA Media;
        ACCESS_ERROR_LOG ErrLog;
        ACCESSMETHOD_TULIP Tulip;
        ACCESS_MUX_SMBUS MuxSmbus;
        ACCESS_MUX_ID_PROM MuxIdProm;
        ACCESS_MUX_I2C MuxI2C;
    } Access;
} ACCESS_METHOD, *PACCESS_METHOD;
typedef struct _MA_MEM_RECORD
{
    WORD MemDeviceHandle;
    BYTE HotSpareStatus;
} MA_MEM_RECORD, *PMA_MEM_RECORD;
typedef struct _MA_ADD_DEVICE_PROPERTIES
{
    BYTE MemRecordSize;
    MA_MEM_RECORD MemoryRecord[1];
} MA_ADD_DEVICE_PROPERTIES, *PMA_ADD_DEVICE_PROPERTIES;
typedef struct _MA_SCRUBBING_PROPERTIES
{
    BYTE NrScrubbingRuns;
} MA_SCRUBBING_PROPERTIES, *PMA_SCRUBBING_PROPERTIES;
#pragma pack()
#pragma pack(1)
typedef struct _DMI_DATA
{
    UCHAR Type;
    UCHAR Length;
    USHORT Handle;
    UCHAR SubType;
    UCHAR HardwareId;
    UCHAR AccessMethod[128];
} DMI_DATA, *PDMI_DATA;
typedef struct _SYSMON_EXTENSION
{
    UCHAR SubType;
    UCHAR HardwareId;
    union
    {
        ACCESSMETHOD_PIIX_GPIO AccessGPIO;
        ACCESSMETHOD_PIIX_GPIO_LOW AccessGPIOLow;
        ACCESSMETHOD_PIIX_SMBUS AccessSMBus;
        ACCESSMETHOD_NAUTILUS_ISA AccessNautilusISA;
        ACCESSMETHOD_CALC AccessAsic[22];
        ACCESSMETHOD_EINSCHALTTIMER AccessOnTimer;
        ACCESSMETHOD_SIO AccessSuperIO;
        ACCESSMETHOD_DMI_BIOS AccessDMIBios;
    }
      access
      ;
} SYSMON_EXTENSION, *PSYSMON_EXTENSION;
#pragma pack()
typedef struct _DEVICE_EXTENSION
{
    ULONG ulDeviceNumber;
    ULONG ulOpenCount;
    ULONG SupportedHardware;
    BOOL bSupportPIIX4;
    BOOL bSupportICH;
    BOOL bSupportNautilusISA;
    BOOL bSupportNautilus;
    BOOL bSupportPegasus;
    BOOL bSupportPoseidon;
    BOOL bSupportPoseidonII;
    BOOL bSupportHydra;
    BOOL bSupportWinBond;
    BOOL bSupportKeelung;
    BOOL bSupportSMAsic;
    ULONG ulPIIX4_ICH_BusNumber_F0;
    ULONG ulPIIX4_ICH_SlotNumber_F0;
    ULONG ulPIIX4_ICH_BusNumber_F2;
    ULONG ulPIIX4_ICH_SlotNumber_F2;
    ULONG ulPIIX4_ICH_BusNumber_F3;
    ULONG ulPIIX4_ICH_SlotNumber_F3;
    ULONG ulPIIX4_ICH_GPIPort;
    ULONG ulPIIX4_ICH_GPOPort;
    ULONG ulPIIX4_ICH_PortSC;
    ULONG ulPIIX4_ICH_GPIUseSelectPort;
    ULONG ulPIIX4_ICH_GPE1_STSPort;
    ULONG ulPIIX4_ICH_TCO2_STSPort;
    ULONG ulSMBus_BaseAddress;
    ULONG ulSMBus_MaxRetry;
    ULONG ulSMBus_Sleep;
    ULONG ulSMBus_TimeOut;
    SYSMON_EXTENSION SystemMonitoringData[35];
    LONG FanSleep;
    LONG FanFaultSleep;
    UCHAR MinFanSpeed_SV;
    UCHAR MaxFanSpeed_SV;
    UCHAR FanPuls_SV;
    UCHAR FanAging_SV;
    UCHAR Fan_CPU_A_Max_Ref;
    UCHAR Fan_CPU_B_Max_Ref;
    UCHAR Fan_AUX_Max_Ref;
    UCHAR Fan_SV_Max_Ref;
    UCHAR Fan_SV2_Max_Ref;
    UCHAR Fan_System_Max_Ref;
    UCHAR MinVoltage5;
    UCHAR MaxVoltage5;
    UCHAR MinVoltage12;
    UCHAR MaxVoltage12;
    UCHAR MinVoltageBatt;
    UCHAR MaxVoltageBatt;
    UCHAR ucCPUAvailable[4];
    UCHAR ucNrCPU;
    ULONG SetValue;
    ULONG SWWatchdogPresetTime;
    UCHAR SWWatchdogTimeBase;
    BOOL SWWatchdogAlert;
    BOOL bSupportRedundantPS;
    UCHAR RedundantPSStatus;
    ULONG NrPowersupplies;
    ULONG ObjectId;
    char SVString[255];
    BOOL bSupportMonitorSV;
    BOOL bSupportFanOffNFull;
    USHORT usSVStringNMAX;
    USHORT usSVStringNMIN;
    UCHAR ucSVStringREF;
    UCHAR ucSVStringFANPULS;
    char RiserString[255];
    BOOL bSupportTempSens;
    UCHAR RiserCabinet;
    USHORT usDMICabinetID;
    char GeometryString[255];
    BOOL bMonitorSVInitiallySwitchedOn;
} DEVICE_EXTENSION, *PDEVICE_EXTENSION;
typedef struct _RET_VALUE_STRUCT
{
    DWORD Value;
    DWORD Multiplier;
    DWORD Offset;
    DWORD RefVoltage;
}RET_VALUE_STRUCT;
typedef struct _MAXSPEED_STRUCT
{
    DWORD MaxSpeed;
    DWORD RefMaxSpeed;
}RET_MAXSPEED;
typedef struct _RET_VOLTAGE_STRUCT
{
    DWORD Voltage;
    DWORD Multiplier;
    DWORD Offset;
    DWORD RefVoltage;
    DWORD MinVoltage;
    DWORD MaxVoltage;
}RET_VOLTAGE_STRUCT;
typedef struct _RET_FAN_STRUCT
{
    DWORD Supported;
    DWORD MinSpeed;
    DWORD MaxSpeed;
    DWORD Ripple;
    DWORD Percentage;
}RET_FAN_STRUCT, *PRET_FAN_STRUCT;
typedef struct _RET_TEMP_STRUCT
{
    DWORD Temperature;
    DWORD Multiplier;
    DWORD Offset;
    DWORD RefVoltage;
    DWORD LowWarning;
    DWORD LowCritical;
    DWORD HighWarning;
    DWORD HighCritical;
}RET_TEMP_STRUCT, *PRET_TEMP_STRUCT;
typedef void (*SMBI_CMD_ROUTINE)(void);
#pragma pack (1)
typedef struct _SmbiHeader
{
    DWORD sig0;
    DWORD sig1;
    BYTE version;
    BYTE revision;
    DWORD CMD_Pointer;
    WORD CMD_size;
    DWORD Result_Pointer;
    WORD Result_size;
    DWORD SMB_command32;
    DWORD SMB_command32near;
    DWORD SMB_command16;
} SMBI_HEADER, *P_SMBI_HEADER;
typedef struct CMD_PACKET {
    BYTE OpCode;
    BYTE SubOpCode;
    union {
        BYTE SetBoot_Boot_Device;
        BYTE SetBoot_Diagnostic_Device;
        struct {
            BYTE AutoPower_Second;
            BYTE AutoPower_Minute;
            BYTE AutoPower_Hour;
            BYTE AutoPower_DayOfMonth;
            BYTE AutoPower_Month;
            BYTE AutoPower_Year;
            BYTE AutoPower_Century;
        } autopower;
        BYTE Set_ACLR;
        BYTE WatchDog_Time;
        BYTE Retry_Counter;
        BYTE Critical_Flag;
        BYTE Delay_Time;
        BYTE Voltage_No;
        struct {
            BYTE SMBus_Channel;
            BYTE SMBus_Address;
            BYTE SMBus_Offset;
            union {
                BYTE SMBus_Data_Byte;
                WORD SMBus_Data_Word;
            } smdat;
        } smbus;
        BYTE CPU_Instance;
        BYTE FAN_Instance;
        struct {
            BYTE BI_Day;
            BYTE BI_Month;
            BYTE BI_Year;
            BYTE BI_Century;
        } date;
    }
      data
      ;
} COMMAND_PACKET, *P_COMMAND_PACKET;
typedef struct RESULT_PACKET {
    BYTE Status;
    BYTE Len;
    union {
        struct {
            BYTE LOG_Header_version;
            BYTE LOG_Header_NrOfMaxEntries;
            BYTE LOG_Header_NrOfEntries;
        } eventhdr;
        struct {
            BYTE Log_Type;
            BYTE Sub_Type;
            BYTE _Century;
            BYTE _Year;
            BYTE _Month;
            BYTE _Day;
            BYTE _Hour;
            BYTE _Minute;
            BYTE _Second;
            union {
                struct {
                    WORD row_address;
                    BYTE row_number;
                    WORD column_address;
                    BYTE ECC_Syndrome;
                } sbelog;
                struct{
                    BYTE device_id;
                    BYTE reg_offset;
                } smblog;
            }
            memerr
            ;
        } eventlog;
        struct {
            BYTE WatchDog_Time;
            BYTE Active_Timer;
        } watchdog;
        BYTE Get_ACLR;
        BYTE Retry_Counter;
        BYTE Delay_Time;
        BYTE SMBus_Data_Byte;
        WORD SMBus_Data_Word;
        BYTE GetBoot_Boot_Device;
        BYTE GetBoot_Diagnostic_Device;
        BYTE Critical_Flag;
        struct {
            BYTE Max_CPUs;
            BYTE CPU_Status[4];
        } qcpu;
        struct {
            BYTE Information_Map;
            WORD CPU_Voltage;
            WORD CPU_Temperature;
            WORD CPU_Fan_Speed;
        } getcpu;
        struct {
            BYTE BI_Day;
            BYTE BI_Month;
            BYTE BI_Year;
            BYTE BI_Century;
        } date;
        WORD Voltage;
    }
      data
      ;
} RESLT_PACKET, *P_RESLT_PACKET;
#pragma pack ()
#ident "$HEADER$"
typedef VOID (*BAPI_CMD_ROUTINE)(ULONG InBuffer, ULONG OutBuffer, ULONG ControlBuffer);
#pragma pack(1)
typedef union _BAPI_SIGN
{
    BYTE SignByte[sizeof(DWORD)];
    DWORD SignDword;
} BAPI_SIGN, *PBAPI_SIGN;
typedef struct _BIOS_API_HEADER
{
    DWORD Signature;
    BYTE Length;
    BYTE Checksum;
    BYTE Version;
    BYTE Reserved;
    WORD BIOS_16_Offset;
    DWORD BIOS_16_Base;
    WORD BIOS_32_Offset;
    DWORD BIOS_32_Base;
} BIOS_API_HEADER, *P_BIOS_API_HEADER;
typedef union _BIOS_API_CONTROL
{
    struct
    {
        WORD Length;
        DWORD Signature;
        DWORD ServiceCode;
        BYTE Reserved[6];
    }In;
    struct
    {
        WORD Length;
        DWORD Signature;
        DWORD ActionCode;
        BYTE GeneralStatus;
        WORD ErrorCode;
        BYTE Reserved[3];
    }Out;
} BIOS_API_CONTROL, *PBIOS_API_CONTROL;
typedef union _BIOS_API_CONTROL_BUFFER
{
    BIOS_API_CONTROL Control;
    BYTE ScratchPad[1024];
} BIOS_API_CONTROL_BUFFER, *PBIOS_API_CONTROL_BUFFER;
typedef union _BIOS_API_BUFFER
{
    struct
    {
        WORD Length;
        union
        {
            struct
            {
                DWORD Reserved;
            } Snibs;
            struct
            {
                WORD Reserved;
                struct
                {
                    DWORD Address;
                    DWORD Length;
                }Segment;
            }Snifu;
            struct
            {
                DWORD Empty;
            }Snifa;
            struct
            {
                DWORD Parameter;
            }Snism;
            struct
            {
                BYTE Seconds;
                BYTE Minutes;
                BYTE Hours;
                BYTE Day;
                BYTE Month;
                BYTE Year;
                BYTE Century;
                BYTE DayOfWeek;
            }Snion;
            struct
            {
                DWORD Signature;
                WORD NrOfModules;
                WORD TotalErrors;
                WORD ErrorModule[6];
                BYTE Reserved[26];
            }Snime;
        }Svc;
    }In;
    struct
    {
        WORD Length;
        union
        {
            struct
            {
                DWORD BufSize;
                BYTE Reserved[26];
            }Snibs;
            struct
            {
                DWORD Empty;
            }Snifu;
            struct
            {
                WORD Reserved;
                struct
                {
                    DWORD Address;
                    DWORD Length;
                }Segment[1];
            }Snifa;
            struct
            {
                DWORD Parameter;
            }Snism;
            struct
            {
                BYTE Seconds;
                BYTE Minutes;
                BYTE Hours;
                BYTE Day;
                BYTE Month;
                BYTE Year;
                BYTE Century;
                BYTE DayOfWeek;
            }Snion;
            struct
            {
                DWORD Signature;
                WORD NrOfModules;
                WORD TotalErrors;
                WORD ErrorModule[6];
                BYTE Reserved[26];
            }Snime;
        }Svc;
    } Out;
} BIOS_API_BUFFER, *PBIOS_API_BUFFER;
typedef struct _BAPI_EVENTS
{
    union
    {
        struct
        {
            WORD Length;
            DWORD Signature;
            QWORD Features;
            QWORD Events;
        } Sniev;
        BYTE AsBytes[32];
    } Svc;
} BIOS_API_EVENTS, *P_BIOS_API_EVENTS;
typedef struct _BAPI_EVENTS_STRUCT
{
    P_BIOS_API_EVENTS pEventsIn;
    P_BIOS_API_EVENTS pEventsOut;
} BAPI_EVENTS_STRUCT, *PBAPI_EVENTS_STRUCT;
typedef struct _BAPI_MEMORY_ERRORS
{
    union
    {
        struct
        {
            WORD Length;
            DWORD Signature;
            WORD NrOfModules;
            WORD TotalErrors;
            WORD ErrorModule[16];
            BYTE Reserved[2];
            DWORD Flags;
            DWORD NrErrorDescriptors;
            QWORD ErrorDescriptors[12];
        } Mecs;
        BYTE AsBytes[256];
    } Svc;
} BIOS_API_MEMERRS, *P_BIOS_API_MEMERRS;
typedef struct _BIOS_API
{
    BIOS_API_CONTROL Control;
    BIOS_API_BUFFER Buffer;
    DWORD OutMax;
} BIOS_API, *PBIOS_API;
typedef struct _BAPI_STATIC_BUFFERS
{
    BIOS_API_EVENTS EventsIn;
    BIOS_API_EVENTS EventsOut;
    BIOS_API_MEMERRS MemoryErrors;
} BAPI_STATIC_BUF, *P_BAPI_STATIC_BUF;
#pragma pack()
#ident "$Header$"
#pragma pack(1)
typedef struct _SMBUS_DATA
{
    ulong Command;
    ulong DeviceAddress;
    ulong Data;
    ulong ReturnStatus;
    PBYTE pData;
    DWORD DataLen;
} SMBUS_DATA, *P_SMBUS_DATA;
typedef struct _SMBI_DATA
{
    char *CmdBuffer;
    ulong CmdBufferLength;
    char *ResBuffer;
    ulong ResBufferLength;
} SMBI_DATA, *P_SMBI_DATA;
typedef struct _IoctlData_indexed_port_io
{
    u_int8_t IndexPort;
    u_int8_t IndexData;
    u_int8_t DataPort;
    u_int8_t DataData;
} IOCTLDATA_INDEXED_PORT_IO, *P_IOCTLDATA_INDEXED_PORT_IO;
typedef struct _IoctlData_generic_io
{
    ulong Address;
    ulong DataWidth;
    ulong WrRdData;
} IOCTLDATA_GEN_IO, *P_IOCTLDATA_GEN_IO;
typedef struct _BAPI_DATA
{
    void *CtlBuffer;
    ulong CtlLength;
    void *InBuffer;
    ulong InLength;
    void *OutBuffer;
    ulong OutLength;
} BAPI_DATA, *P_BAPI_DATA;
typedef struct _Smbus_MuxDeviceAddess
{
    BYTE Address;
    BYTE Offset;
    BYTE Protocol;
    BYTE AndMask;
    BYTE OrMask;
    BYTE Reserved[3];
} SMBUS_MUX_ADDR, *P_SMBUS_MUX_ADDR;
typedef struct _IoctlData_Smbus_OpenDevice
{
    BYTE DeviceAddress;
    DWORD MuxesToProcess;
    P_SMBUS_MUX_ADDR pMuxAddr;
} IOCTLDATA_SMBUS_OPEN_DEVICE, *P_IOCTLDATA_SMBUS_OPEN_DEVICE;
typedef struct _IoctlData_Smbus_WriteDevice
{
    DWORD StartOffset;
    DWORD BytesToProcess;
    PBYTE pProcessData;
} IOCTLDATA_SMBUS_DEVICE, *P_IOCTLDATA_SMBUS_DEVICE;
typedef struct _SMBUS_DEVICE_DATA
{
    DWORD DeviceHandle;
    BOOL Success;
    union {
        IOCTLDATA_SMBUS_OPEN_DEVICE Open;
        IOCTLDATA_SMBUS_DEVICE Access;
    } u;
} SMBUS_DEVICE_DATA, *P_SMBUS_DEVICE_DATA;
typedef struct _IoctlData_Smbus_MasterInfo
{
    WORD VendorId;
    WORD DeviceId;
    WORD BaseAddress;
} IOCTLDATA_SMBUS_MASTER_INFO, *P_IOCTLDATA_SMBUS_MASTER_INFO;
#pragma pack()
#ident "$Header$"
#ident "$Header$"
enum ChipsetType
{
    CS_UNKNOWN,
    CS_INTEL_PIIX4,
    CS_INTEL_ICH,
    CS_RCC_OSB4,
    CS_RCC_CSB5,
    CS_RCC_CSB6,
    CS_VIA_686A,
    CS_VIA_8233
};
extern DWORD smbus_ReadData(BYTE DeviceAddress, BYTE StartOffset, PBYTE pReturnBuffer, DWORD BytesToRead);
extern DWORD smbus_WriteData(BYTE DeviceAddress, BYTE StartOffset, PBYTE pWriteData, DWORD BytesToWrite);
extern DWORD smbus_ReadOneByte(BYTE DeviceAddress, PBYTE pReturnByte);
extern DWORD smbus_WriteOneByte(BYTE DeviceAddress, BYTE WriteData);
extern INT smbus_OpenDevice(PDWORD pDeviceHandle, PVOID pDeviceAddressData, DWORD AddrTableSize);
extern INT smbus_CloseDevice(DWORD DeviceHandle);
extern INT smbus_ReadDevice(DWORD DeviceHandle, BYTE Offset, DWORD BytesToRead, PBYTE pReturnBuffer, PDWORD pBytesRead);
extern INT smbus_WriteDevice (DWORD DeviceHandle, BYTE Offset, DWORD BytesToWrite, PBYTE pWriteBuffer);
extern BOOL smbus_ReadByte(BYTE DeviceAddress, BYTE Offset, PBYTE pData, BOOL NotUseOffset);
extern BOOL smbus_WriteByte(BYTE DeviceAddress, BYTE Offset, BYTE Data, BOOL NotUseOffset);
extern BOOL smbus_CheckHardwareType(PULONG pulType);
extern void smbus_PowerDown(void);
extern void asus_PowerDown(char *CmdBuffer, char *ResultBuffer, SMBI_CMD_ROUTINE fSmbiExec);
extern BOOL smbus_ResetSMBusCtrl (void);
extern enum ChipsetType Chipset;
extern DWORD ulSMBusBaseAddress;
extern PVOID OpenDevices[];
extern short smbusDebug;
EXPORT_NO_SYMBOLS;
short smbusDebug = 0;
MODULE_PARM(smbusDebug, "h");
static char *SMBUS_DEV = "smbus";
static int smbus_major = 0;
static DECLARE_MUTEX(smbus_mutex);
static struct _SmBusIoBaseAddresses
{
    WORD VendorId;
    WORD DeviceId;
    BYTE AddressReg;
    BYTE Chipset;
    char *pChipName;
} SmBusIoBaseAddresses[] =
{
    { 0x8086, 0x7113, 0x90, CS_INTEL_PIIX4, "Intel PIIX4" },
    { 0x8086, 0x2413, 0x20, CS_INTEL_ICH, "Intel ICH" },
    { 0x8086, 0x2443, 0x20, CS_INTEL_ICH, "Intel ICH2" },
    { 0x8086, 0x24C3, 0x20, CS_INTEL_ICH, "Intel ICH4" },
    { 0x8086, 0x24D3, 0x20, CS_INTEL_ICH, "Intel ICH5" },
    { 0x1166, 0x0200, 0x90, CS_RCC_OSB4, "RCC OSB4" },
    { 0x1166, 0x0201, 0x90, CS_RCC_CSB5, "RCC CSB5" },
    { 0x1166, 0x0203, 0x90, CS_RCC_CSB6, "RCC CSB6" },
    { 0x1106, 0x3057, 0x90, CS_VIA_686A, "VIA 82C868A" },
    { 0x1106, 0x3074, 0xD0, CS_VIA_8233, "VIA 8233" },
    { 0, 0, 0, 0, "" }
};
enum ChipsetType Chipset = CS_UNKNOWN;
LPSTR pChipName = "UNKNOWN";
struct pci_dev *SmbusPcidev_p = NULL;
DWORD ulSMBusBaseAddress = 0;
PVOID OpenDevices[32] = {};
static int SmBusDeviceIndex = -1;
static ULONG ulPIIX4_ICH_GPIPort = 0;
static ULONG ulPIIX4_ICH_GPOPort = 0;
static ULONG ulPIIX4_ICH_TCO2_STSPort = 0;
static ULONG ulPIIX4_ICH_GPIUseSelectPort = 0;
static SMBI_HEADER *m_pSmbiBase = NULL;
static SMBI_CMD_ROUTINE m_fSmbiExec = NULL;
static char *ulASUSCmdBuffer;
static char *ulASUSResultBuffer;
static BIOS_API_HEADER *m_pBapiBase = NULL;
static BAPI_CMD_ROUTINE m_fBapiExec = NULL;
static BIOS_API_CONTROL_BUFFER *pBAPIControlBuffer = NULL;
static BIOS_API_BUFFER *pBAPIDataBuffer = NULL;
static BAPI_STATIC_BUF *pBAPIStaticPage = NULL;
static int FindAsusBuffers(ulong base, ulong offset, ulong size, char *signature)
{
    int i;
    char *BaseAddress;
    BaseAddress = (char *)phys_to_virt(base);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "ASUSSearchAddress = 0x%p (0x%lx) [+0x%lx,0x%lx]\n",BaseAddress, base, offset, size); } while (0);
    if (BaseAddress)
    {
        unsigned char *Address = BaseAddress + offset;
        int siglen = strlen(signature);
        for (i = 0; i < size; i++)
        {
            char *p_work = (char *)(Address + i);
            if (strncmp(p_work, signature, siglen) == 0)
            {
                m_pSmbiBase = (SMBI_HEADER *)p_work;
                break;
            }
        }
        if (m_pSmbiBase != NULL)
        {
            do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "ASUSHeader = 0x%p (0x%lx)\n",m_pSmbiBase, ((char *)m_pSmbiBase - BaseAddress + base)); } while (0);
            ulASUSCmdBuffer = BaseAddress + (m_pSmbiBase->CMD_Pointer - base);
            ulASUSResultBuffer = BaseAddress + (m_pSmbiBase->Result_Pointer - base);
            m_fSmbiExec = (SMBI_CMD_ROUTINE)(BaseAddress + (m_pSmbiBase->SMB_command32near - base));
            do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "ASUSCmdExec = 0x%p (0x%lx)\n",m_fSmbiExec, (ulong)m_pSmbiBase->SMB_command32near); } while (0);
            do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "ASUSCmdBuffer = 0x%p (0x%lx)\n",ulASUSCmdBuffer, (ulong)m_pSmbiBase->CMD_Pointer); } while (0);
            do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "ASUSResultBuffer = 0x%p (0x%lx)\n",ulASUSResultBuffer, (ulong)m_pSmbiBase->Result_Pointer); } while (0);
            return 1;
        }
    }
    return 0;
}
static int FindBapiBuffers(ulong base, ulong offset, ulong size, ulong signature)
{
    int i;
    char *BaseAddress;
    BaseAddress = (char *)phys_to_virt(base);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "BAPISearchAddress = 0x%p (0x%lx) [+0x%lx,0x%lx]\n",BaseAddress, base, offset, size); } while (0);
    if (BaseAddress)
    {
        unsigned char *Address = BaseAddress + offset;
        for (i = 0; i < size; i++)
        {
            ulong *p_work = (ulong *)(Address + i);
            if (*p_work == signature)
            {
                m_pBapiBase = (BIOS_API_HEADER *)p_work;
                break;
            }
        }
        if (m_pBapiBase != NULL)
        {
            char Checksum = 0;
            do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "BAPIHeader = 0x%p (0x%lx)\n",m_pBapiBase, ((char *)m_pBapiBase - BaseAddress + base)); } while (0);
            for (i = 0; i < m_pBapiBase->Length; i++)
            {
                Checksum += ((PBYTE)m_pBapiBase)[i];
            }
            if (Checksum != 0) printk(KERN_NOTICE "WARNING: BAPI HeaderChecksum ERROR\n");
            m_fBapiExec = (BAPI_CMD_ROUTINE)(BaseAddress + (m_pBapiBase->BIOS_32_Base + m_pBapiBase->BIOS_32_Offset - base));
            do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "BAPICmdExec = 0x%p (0x%lx)\n",m_fBapiExec, (ulong)(m_pBapiBase->BIOS_32_Base + m_pBapiBase->BIOS_32_Offset)); } while (0);
            pBAPIControlBuffer = (BIOS_API_CONTROL_BUFFER *)kmalloc(sizeof(BIOS_API_CONTROL_BUFFER), GFP_KERNEL);
            pBAPIDataBuffer = (BIOS_API_BUFFER *)kmalloc(sizeof(BIOS_API_BUFFER), GFP_KERNEL);
            do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "BAPIBuffers = Control 0x%p, Data 0x%p\n",pBAPIControlBuffer, pBAPIDataBuffer); } while (0);
            pBAPIStaticPage = (BAPI_STATIC_BUF *)get_free_page(GFP_KERNEL);
            do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "BAPIStaticPage = 0x%p\n",pBAPIStaticPage); } while (0);
            mem_map_reserve(virt_to_page(pBAPIStaticPage));
            return 1;
        }
    }
    return 0;
}
static int isSMHardware()
{
    u32 addr;
    int i;
    struct pci_dev *g_smbusDev = NULL;
    i = 0;
    Chipset = CS_UNKNOWN;
    while ((SmBusIoBaseAddresses[i].VendorId != 0) && (SmBusIoBaseAddresses[i].DeviceId != 0))
    {
        g_smbusDev = pci_find_device(SmBusIoBaseAddresses[i].VendorId, SmBusIoBaseAddresses[i].DeviceId, NULL);
        if (g_smbusDev != NULL)
        {
            do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "## SM bus device found: %s\n",SmBusIoBaseAddresses[i].pChipName); } while (0);
            pci_read_config_dword(g_smbusDev, SmBusIoBaseAddresses[i].AddressReg, &addr);
            ulSMBusBaseAddress = addr & 0x0000FFFC;
            do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "SMBusBaseAddress = 0x%04X\n",ulSMBusBaseAddress); } while (0);
            Chipset = SmBusIoBaseAddresses[i].Chipset;
            pChipName = SmBusIoBaseAddresses[i].pChipName;
            SmbusPcidev_p = g_smbusDev;
            SmBusDeviceIndex = i;
            break;
        }
        i++;
    }
    switch(Chipset)
    {
    case CS_UNKNOWN:
        return 0;
    case CS_INTEL_PIIX4:
        pci_read_config_dword(g_smbusDev, 0x40, &addr);
        ulPIIX4_ICH_GPIPort = (addr + 0x30) & 0xfffffffe;
        ulPIIX4_ICH_GPOPort = (addr + 0x34) & 0xfffffffe;
        do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "PIIX4_ICH_GPIPort = 0x%x\n",(int)ulPIIX4_ICH_GPIPort); } while (0);
        do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "PIIX4_ICH_GPOPort = 0x%x\n",(int)ulPIIX4_ICH_GPOPort); } while (0);
        break;
    case CS_INTEL_ICH:
        pci_read_config_dword(g_smbusDev, 0x40, &addr);
        ulPIIX4_ICH_TCO2_STSPort = (addr + 0x60 + 0x06) & 0xfffffffe;
        pci_read_config_dword(g_smbusDev, 0x58, &addr);
        ulPIIX4_ICH_GPIUseSelectPort = (addr + 0x00) & 0xfffffffe;
        do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "PIIX4_ICH_TCO2_STSPort = 0x%x\n",(int)ulPIIX4_ICH_TCO2_STSPort); } while (0);
        do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "PIIX4_ICH_GPIUseSelectPort = 0x%x\n",(int)ulPIIX4_ICH_GPIUseSelectPort); } while (0);
        break;
    case CS_RCC_OSB4:
    case CS_VIA_686A:
        (void)FindAsusBuffers(0xE0000, 0x10000, 0x10000, "SMBIASUS");
        break;
    default:
        break;
    }
    (void)FindBapiBuffers(0xE0000, 0x10000, 0x10000, 0x4DC94253);
    return 1;
}
BOOL CheckForIntrusionSupport()
{
    switch(Chipset)
    {
    case CS_INTEL_PIIX4:
        return (ulPIIX4_ICH_GPIPort && ulPIIX4_ICH_GPOPort);
    case CS_INTEL_ICH:
        return (ulPIIX4_ICH_GPIUseSelectPort && ulPIIX4_ICH_TCO2_STSPort);
    default:
        break;
    }
    return 0;
}
BOOL CheckForCabinetIntrusion()
{
    BOOL bCabinetOpened = 0;
    BOOL bUseSel;
    UCHAR ucValue;
    ULONG ulValue;
    switch(Chipset)
    {
    case CS_INTEL_ICH:
        ulValue = inl_p(ulPIIX4_ICH_GPIUseSelectPort);
        bUseSel = 0;
        if (ulValue & 0x400)
        {
            bUseSel = 1;
            ulValue &= ~0x400;
            outl_p(ulPIIX4_ICH_GPIUseSelectPort, ulValue);
        }
        ucValue = inb_p(ulPIIX4_ICH_TCO2_STSPort);
        if (ucValue & 0x01)
        {
            bCabinetOpened = 1;
            ucValue &= 0x01;
            outb_p(ucValue, ulPIIX4_ICH_TCO2_STSPort);
        }
        if (bUseSel)
        {
            ulValue = inl_p(ulPIIX4_ICH_GPIUseSelectPort);
            ulValue |= 0x400;
            outl_p(ulPIIX4_ICH_GPIUseSelectPort, ulValue );
        }
        return bCabinetOpened;
    case CS_INTEL_PIIX4:
        ulValue = inl_p(ulPIIX4_ICH_GPIPort);
        if (ulValue == 0) return 0;
        ulValue = inl_p(ulPIIX4_ICH_GPOPort);
        ulValue &= 0xFEFF;
        outl_p(ulPIIX4_ICH_GPOPort, ulValue);
        ulValue |= 0x0100;
        outl_p(ulPIIX4_ICH_GPOPort, ulValue);
        return 1;
    default:
        break;
    }
    return 0;
}
BOOL smbus_ResetSMBusCtrl(void)
{
        BOOL Success = 0;
        BYTE ConfigReg;
        do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "smbus_ResetSMBusCtrl: RESET Chipset %s (%d)\n",pChipName, Chipset); } while (0);
        switch(Chipset)
        {
        case CS_UNKNOWN:
                do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "smbus_ResetSMBusCtrl: NO CHIPSET DETECTED\n"); } while (0);
                break;
        case CS_RCC_CSB5:
                {
                        pci_read_config_byte(SmbusPcidev_p, 0x40, &ConfigReg);
                        ConfigReg |= 0x10;
                        do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "smbus_ResetSMBusCtrl: RESET REG %02X (%02X)\n",0x40,ConfigReg); } while (0);
                        pci_write_config_byte(SmbusPcidev_p, 0x40, ConfigReg);
                        udelay(10);
                        pci_read_config_byte(SmbusPcidev_p, 0x40, &ConfigReg);
                        ConfigReg &= ~0x10;
                        do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "smbus_ResetSMBusCtrl: RELEASE RESET REG %02X (%02X)\n",0x40,ConfigReg); } while (0);
                        pci_write_config_byte(SmbusPcidev_p, 0x40, ConfigReg);
                        udelay (10);
                        do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "smbus_ResetSMBusCtrl: SET BASE ADDRESS %02X (%04X)\n",0x90,ulSMBusBaseAddress); } while (0);
                        pci_write_config_dword(SmbusPcidev_p, 0x90, ulSMBusBaseAddress);
                        ConfigReg = 0x03;
                        do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "smbus_ResetSMBusCtrl: ENABLE REG %02X (%02X)\n",0xD2,ConfigReg); } while (0);
                        pci_write_config_byte(SmbusPcidev_p, 0xD2, ConfigReg);
                        Success = 1;
                }
                break;
        default:
                do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "smbus_ResetSMBusCtrl: NO RESET FUNCTION FOR CHIPSET %d\n",Chipset); } while (0);
                break;
        }
        return Success;
}
static void ReadFromIndexedPort(IOCTLDATA_INDEXED_PORT_IO *portio)
{
    outb_p(portio->IndexData, portio->IndexPort);
    portio->DataData = inb_p(portio->DataPort);
}
static void WriteToIndexedPort(IOCTLDATA_INDEXED_PORT_IO *portio)
{
    outb_p(portio->IndexData, portio->IndexPort);
    outb_p(portio->DataData, portio->DataPort);
}
static int smbus_open(struct inode *inode, struct file *file)
{
    do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus :" "smbus_open(0x%p,0x%p)\n",inode, file); } while (0);
    MOD_INC_USE_COUNT;
    return 0;
}
static int smbus_release(struct inode *inode, struct file *file)
{
    do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus :" "smbus_release(0x%p,0x%p)\n",inode, file); } while (0);
    MOD_DEC_USE_COUNT;
    return 0;
}
static int smbus_mmap(struct file *file, struct vm_area_struct *vma)
{
    int status;
    ulong start = (unsigned long)vma->vm_start;
    ulong size = (unsigned long)(vma->vm_end - vma->vm_start);
    do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus :" "smbus_mmap(0x%p,0x%p) start 0x%lx, length %ld\n",file, vma, start, size); } while (0);
    if (size < sizeof(BAPI_STATIC_BUF)) return -EINVAL;
    if (size > PAGE_SIZE) return -EINVAL;
    if (!pBAPIStaticPage) return -ENODEV;
#if defined(REDHAT) && defined(ADVANCED) 
    status = remap_page_range(vma,start, virt_to_phys(pBAPIStaticPage), size, vma->vm_page_prot); 
#else
    status = remap_page_range(start, virt_to_phys(pBAPIStaticPage), size, vma->vm_page_prot);
#endif
    if (status != 0)
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_mmap: remap_page_range of 0x%lx failed: %d\n",virt_to_phys(pBAPIStaticPage), status); } while (0);
        return -EAGAIN;
    }
    return 0;
}
static int smbus_ioctl(struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg)
{
    ULONG ulValue;
    do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus :" "smbus_ioctl(0x%p,0x%p,0x%x,0x%lx) ioctl %d\n",inode, file, cmd, arg, _IOC_NR(cmd)); } while (0);
    if ((_IOC_TYPE(cmd) != 's') || (_IOC_NR(cmd) > 23))
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_ioctl: unsupported ioctl magic %d, nr %d\n",_IOC_TYPE(cmd), _IOC_NR(cmd)); } while (0);
        return -EINVAL;
    }
    switch(cmd)
    {
        case _IOW('s', 5, SMBI_HEADER):
            if (!m_pSmbiBase) return -ENXIO;
            copy_to_user((SMBI_HEADER *)arg, m_pSmbiBase, sizeof(SMBI_HEADER));
            return 0;
        case _IOWR('s',6, SMBI_DATA):
        {
            DWORD length;
            SMBI_DATA smbi;
            if (!m_pSmbiBase) return -ENXIO;
            copy_from_user(&smbi, (SMBI_DATA *)arg, sizeof(SMBI_DATA));
            if (!smbi.CmdBuffer || !smbi.CmdBufferLength) return -EINVAL;
            do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus :" "SMBI cmd 0x%p(%ld) res 0x%p(%ld)\n",smbi.CmdBuffer, smbi.CmdBufferLength, smbi.ResBuffer, smbi.ResBufferLength); } while (0);
            down(&smbus_mutex);
            length = (smbi.CmdBufferLength < m_pSmbiBase->CMD_size) ? smbi.CmdBufferLength : m_pSmbiBase->CMD_size;
            copy_from_user(ulASUSCmdBuffer, smbi.CmdBuffer, length);
            asm("pushl %edx");
            asm("pushl %eax");
            (*m_fSmbiExec)();
            asm("popl %eax");
            asm("popl %edx");
            if (!smbi.ResBuffer || !smbi.ResBufferLength)
            {
                up(&smbus_mutex);
                return 0;
            }
            length = ulASUSResultBuffer[1];
            if (length > m_pSmbiBase->Result_size) length = m_pSmbiBase->Result_size;
            if (length > smbi.ResBufferLength) length = smbi.ResBufferLength;
            copy_to_user(smbi.ResBuffer, ulASUSResultBuffer, length);
            up(&smbus_mutex);
            return 0;
        }
        case _IOR('s', 10, BIOS_API_HEADER):
            if (!m_pBapiBase) return -ENXIO;
            copy_to_user((BIOS_API_HEADER *)arg, m_pBapiBase, sizeof(BIOS_API_HEADER));
            return 0;
        case _IOWR('s',11, BAPI_DATA):
        {
            DWORD length, ctl_length;
            BAPI_DATA bapi;
            if (!m_pBapiBase || !pBAPIControlBuffer || !pBAPIDataBuffer) return -ENXIO;
            copy_from_user(&bapi, (BAPI_DATA *)arg, sizeof(BAPI_DATA));
            if (!bapi.CtlBuffer || !bapi.CtlLength) return -EINVAL;
            if (!bapi.InBuffer || !bapi.InLength) return -EINVAL;
            do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus :" "BAPI ctl 0x%p(%ld) in 0x%p(%ld) out 0x%p(%ld)\n",bapi.CtlBuffer, bapi.CtlLength, bapi.InBuffer, bapi.InLength, bapi.OutBuffer, bapi.OutLength); } while (0);
            down(&smbus_mutex);
            ctl_length = (bapi.CtlLength <= sizeof(BIOS_API_CONTROL)) ? bapi.CtlLength : sizeof(BIOS_API_CONTROL);
            copy_from_user(pBAPIControlBuffer, (BIOS_API_CONTROL_BUFFER *)bapi.CtlBuffer, ctl_length);
            pBAPIControlBuffer->Control.In.Length = sizeof(BIOS_API_CONTROL_BUFFER);
            length = (bapi.InLength <= sizeof(BIOS_API_BUFFER)) ? bapi.InLength : sizeof(BIOS_API_BUFFER);
            copy_from_user(pBAPIDataBuffer, (BIOS_API_BUFFER *)bapi.InBuffer, length);
            (*m_fBapiExec)(virt_to_phys(pBAPIDataBuffer), virt_to_phys(pBAPIDataBuffer), virt_to_phys(pBAPIControlBuffer));
            length = (pBAPIControlBuffer->Control.Out.Length <= ctl_length) ? pBAPIControlBuffer->Control.Out.Length : ctl_length;
            pBAPIControlBuffer->Control.Out.Length = length;
            copy_to_user(bapi.CtlBuffer, (BIOS_API_CONTROL *)pBAPIControlBuffer, length);
            if (bapi.OutBuffer && bapi.OutLength)
            {
                length = (pBAPIDataBuffer->Out.Length <= sizeof(BIOS_API_BUFFER)) ? pBAPIDataBuffer->Out.Length : sizeof(BIOS_API_BUFFER);
                if (length < sizeof pBAPIDataBuffer->Out.Length)
                {
                    length = sizeof pBAPIDataBuffer->Out.Length;
                    pBAPIDataBuffer->Out.Length = 0;
                }
                length = (length <= bapi.OutLength) ? length : bapi.OutLength;
                pBAPIDataBuffer->Out.Length = length;
                copy_to_user(bapi.OutBuffer, (BIOS_API_BUFFER *)pBAPIDataBuffer, length);
            }
            up(&smbus_mutex);
            return 0;
        }
        case _IOWR('s',18, BAPI_DATA):
        case _IOWR('s',19, BAPI_DATA):
        {
            DWORD length, ctl_length;
            BAPI_DATA bapi;
            if (!m_pBapiBase || !pBAPIControlBuffer || !pBAPIStaticPage) return -ENXIO;
            copy_from_user(&bapi, (BAPI_DATA *)arg, sizeof(BAPI_DATA));
            if (!bapi.CtlBuffer || !bapi.CtlLength) return -EINVAL;
            do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus :" "BAPI ctl 0x%p(%ld) ev 0x%p/0x%p me 0x%p\n",bapi.CtlBuffer, bapi.CtlLength, &pBAPIStaticPage->EventsIn, &pBAPIStaticPage->EventsOut, &pBAPIStaticPage->MemoryErrors); } while (0);
            down(&smbus_mutex);
            ctl_length = (bapi.CtlLength <= sizeof(BIOS_API_CONTROL)) ? bapi.CtlLength : sizeof(BIOS_API_CONTROL);
            copy_from_user(pBAPIControlBuffer, (BIOS_API_CONTROL_BUFFER *)bapi.CtlBuffer, ctl_length);
            pBAPIControlBuffer->Control.In.Length = sizeof(BIOS_API_CONTROL_BUFFER);
            switch(cmd)
            {
            case _IOWR('s',18, BAPI_DATA):
                if (pBAPIStaticPage->EventsIn.Svc.Sniev.Length > sizeof(BIOS_API_EVENTS)) pBAPIStaticPage->EventsIn.Svc.Sniev.Length = sizeof(BIOS_API_EVENTS);
                if (pBAPIStaticPage->EventsOut.Svc.Sniev.Length > sizeof(BIOS_API_EVENTS)) pBAPIStaticPage->EventsOut.Svc.Sniev.Length = sizeof(BIOS_API_EVENTS);
                (*m_fBapiExec)(virt_to_phys(&pBAPIStaticPage->EventsIn), virt_to_phys(&pBAPIStaticPage->EventsOut), virt_to_phys(pBAPIControlBuffer));
                break;
            case _IOWR('s',19, BAPI_DATA):
                if (pBAPIStaticPage->MemoryErrors.Svc.Mecs.Length > sizeof(BIOS_API_MEMERRS)) pBAPIStaticPage->MemoryErrors.Svc.Mecs.Length = sizeof(BIOS_API_MEMERRS);
                (*m_fBapiExec)(virt_to_phys(&pBAPIStaticPage->MemoryErrors), virt_to_phys(&pBAPIStaticPage->MemoryErrors), virt_to_phys(pBAPIControlBuffer));
                break;
            }
            length = (pBAPIControlBuffer->Control.Out.Length <= ctl_length) ? pBAPIControlBuffer->Control.Out.Length : ctl_length;
            pBAPIControlBuffer->Control.Out.Length = length;
            copy_to_user(bapi.CtlBuffer, (BIOS_API_CONTROL *)pBAPIControlBuffer, length);
            up(&smbus_mutex);
            return 0;
        }
        case _IOR('s', 0, SMBUS_DATA):
        {
            SMBUS_DATA smbus;
            BYTE cByte;
            copy_from_user(&smbus, (SMBUS_DATA *)arg, sizeof(SMBUS_DATA));
            do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus :" "SMBUS dev 0x%lx off 0x%lx byte 0x%x\n",smbus.DeviceAddress, smbus.Command, (BYTE)smbus.Data); } while (0);
            smbus.ReturnStatus = smbus_ReadByte(smbus.DeviceAddress, smbus.Command, &cByte, 0);
            smbus.Data = (ULONG)cByte;
            copy_to_user((SMBUS_DATA *)arg, &smbus, sizeof(SMBUS_DATA));
            return 0;
        }
        case _IOW('s', 1, SMBUS_DATA):
        {
            SMBUS_DATA smbus;
            BYTE cByte;
            copy_from_user(&smbus, (SMBUS_DATA *)arg, sizeof(SMBUS_DATA));
            cByte = (BYTE)smbus.Data;
            do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus :" "SMBUS dev 0x%lx off 0x%lx\n",smbus.DeviceAddress, smbus.Command); } while (0);
            smbus.ReturnStatus = smbus_WriteByte(smbus.DeviceAddress, smbus.Command, cByte, 0);
            copy_to_user((SMBUS_DATA *)arg, &smbus, sizeof(SMBUS_DATA));
            return 0;
        }
        case _IOR('s', 12, SMBUS_DATA):
        {
            SMBUS_DATA smbus;
            BYTE SBuffer[sizeof(ulong)];
            PBYTE pBuffer = SBuffer;
            PBYTE pBAlloc = NULL;
            DWORD iLength;
            copy_from_user(&smbus, (SMBUS_DATA *)arg, sizeof(SMBUS_DATA));
            if (!smbus.pData || !smbus.DataLen || (smbus.DataLen > 256)) return -EINVAL;
            do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus :" "SMBUS dev 0x%lx off 0x%lx data 0x%p len %d\n",smbus.DeviceAddress, smbus.Command, smbus.pData, smbus.DataLen); } while (0);
            if (smbus.DataLen > sizeof SBuffer)
            {
                pBAlloc = pBuffer = (PBYTE)kmalloc(smbus.DataLen, GFP_USER);
                if (!pBAlloc) return -EAGAIN;
            }
            iLength = smbus_ReadData(smbus.DeviceAddress, smbus.Command, pBuffer, smbus.DataLen);
            smbus.ReturnStatus = (iLength == smbus.DataLen);
            if (iLength > smbus.DataLen) iLength = smbus.DataLen;
            if (iLength > 0) copy_to_user(smbus.pData, pBuffer, iLength);
            smbus.DataLen = iLength;
            copy_to_user((SMBUS_DATA *)arg, &smbus, sizeof(SMBUS_DATA));
            if (pBAlloc) kfree(pBAlloc);
            return 0;
        }
        case _IOR('s', 13, SMBUS_DATA):
        {
            SMBUS_DATA smbus;
            BYTE SBuffer[sizeof(ulong)];
            PBYTE pBuffer = SBuffer;
            PBYTE pBAlloc = NULL;
            DWORD iLength;
            copy_from_user(&smbus, (SMBUS_DATA *)arg, sizeof(SMBUS_DATA));
            if (!smbus.pData || !smbus.DataLen || (smbus.DataLen > 256)) return -EINVAL;
            do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus :" "SMBUS dev 0x%lx off 0x%lx data 0x%p len %d\n",smbus.DeviceAddress, smbus.Command, smbus.pData, smbus.DataLen); } while (0);
            if (smbus.DataLen > sizeof SBuffer)
            {
                pBAlloc = pBuffer = (PBYTE)kmalloc(smbus.DataLen, GFP_USER);
                if (!pBAlloc) return -EAGAIN;
            }
            copy_from_user(pBuffer, smbus.pData, smbus.DataLen);
            iLength = smbus_WriteData(smbus.DeviceAddress, smbus.Command, pBuffer, smbus.DataLen);
            smbus.ReturnStatus = (iLength == smbus.DataLen);
            if (iLength < smbus.DataLen) smbus.DataLen = iLength;
            copy_to_user((SMBUS_DATA *)arg, &smbus, sizeof(SMBUS_DATA));
            if (pBAlloc) kfree(pBAlloc);
            return 0;
        }
        case _IOWR('s',14, SMBUS_DEVICE_DATA):
        {
            SMBUS_DEVICE_DATA smdev;
            P_IOCTLDATA_SMBUS_OPEN_DEVICE pMuxData = NULL;
            DWORD aLength;
            copy_from_user(&smdev, (SMBUS_DEVICE_DATA *)arg, sizeof(SMBUS_DEVICE_DATA));
            if (smdev.u.Open.MuxesToProcess > 32) return -EINVAL;
            do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus :" "SMDEV dev 0x%02x pmux 0x%p muxes %d\n",smdev.u.Open.DeviceAddress, smdev.u.Open.pMuxAddr, smdev.u.Open.MuxesToProcess); } while (0);
            if (!smdev.u.Open.pMuxAddr) smdev.u.Open.MuxesToProcess = 0;
            aLength = sizeof(IOCTLDATA_SMBUS_OPEN_DEVICE) + (smdev.u.Open.MuxesToProcess * sizeof(SMBUS_MUX_ADDR));
            pMuxData = (P_IOCTLDATA_SMBUS_OPEN_DEVICE)kmalloc(aLength, GFP_USER);
            if (!pMuxData) return -EAGAIN;
            *pMuxData = smdev.u.Open;
            pMuxData->pMuxAddr = NULL;
            if (smdev.u.Open.MuxesToProcess > 0)
            {
                pMuxData->pMuxAddr = (P_SMBUS_MUX_ADDR)&pMuxData[1];
                copy_from_user(pMuxData->pMuxAddr, smdev.u.Open.pMuxAddr, (smdev.u.Open.MuxesToProcess * sizeof(SMBUS_MUX_ADDR)));
            }
            smdev.Success = (smbus_OpenDevice(&smdev.DeviceHandle, pMuxData, aLength) == 0);
            copy_to_user((SMBUS_DEVICE_DATA *)arg, &smdev, sizeof(SMBUS_DEVICE_DATA));
            return 0;
        }
        case _IOR('s', 15, SMBUS_DEVICE_DATA):
        {
            SMBUS_DEVICE_DATA smdev;
            copy_from_user(&smdev, (SMBUS_DEVICE_DATA *)arg, sizeof(SMBUS_DEVICE_DATA));
            do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus :" "SMDEV handle %d dev 0x%02x\n",smdev.DeviceHandle, smdev.u.Open.DeviceAddress); } while (0);
            smdev.Success = (smbus_CloseDevice(smdev.DeviceHandle) == 0);
            copy_to_user((SMBUS_DEVICE_DATA *)arg, &smdev, sizeof(SMBUS_DEVICE_DATA));
            return 0;
        }
        case _IOR('s', 16, SMBUS_DEVICE_DATA):
        {
            SMBUS_DEVICE_DATA smdev;
            BYTE SBuffer[sizeof(ulong)];
            PBYTE pBuffer = SBuffer;
            PBYTE pBAlloc = NULL;
            DWORD iLength;
            copy_from_user(&smdev, (SMBUS_DEVICE_DATA *)arg, sizeof(SMBUS_DEVICE_DATA));
            if (!smdev.u.Access.pProcessData || !smdev.u.Access.BytesToProcess || (smdev.u.Access.BytesToProcess > 256)) return -EINVAL;
            do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus :" "SMDEV handle %d off %d data 0x%p len %d\n",smdev.DeviceHandle, smdev.u.Access.StartOffset, smdev.u.Access.pProcessData, smdev.u.Access.BytesToProcess); } while (0);
            if (smdev.u.Access.BytesToProcess > sizeof SBuffer)
            {
                pBAlloc = pBuffer = (PBYTE)kmalloc(smdev.u.Access.BytesToProcess, GFP_USER);
                if (!pBAlloc) return -EAGAIN;
            }
            smdev.Success = (smbus_ReadDevice(smdev.DeviceHandle, smdev.u.Access.StartOffset, smdev.u.Access.BytesToProcess, pBuffer, &iLength) == 0);
            if (iLength > smdev.u.Access.BytesToProcess) iLength = smdev.u.Access.BytesToProcess;
            if (iLength > 0) copy_to_user(smdev.u.Access.pProcessData, pBuffer, iLength);
            smdev.u.Access.BytesToProcess = iLength;
            copy_to_user((SMBUS_DEVICE_DATA *)arg, &smdev, sizeof(SMBUS_DEVICE_DATA));
            if (pBAlloc) kfree(pBAlloc);
            return 0;
        }
        case _IOW('s', 17, SMBUS_DEVICE_DATA):
        {
            SMBUS_DEVICE_DATA smdev;
            BYTE SBuffer[sizeof(ulong)];
            PBYTE pBuffer = SBuffer;
            PBYTE pBAlloc = NULL;
            copy_from_user(&smdev, (SMBUS_DEVICE_DATA *)arg, sizeof(SMBUS_DEVICE_DATA));
            if (!smdev.u.Access.pProcessData || !smdev.u.Access.BytesToProcess || (smdev.u.Access.BytesToProcess > 256)) return -EINVAL;
            do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus :" "SMDEV handle %d off %d data 0x%p len %d\n",smdev.DeviceHandle, smdev.u.Access.StartOffset, smdev.u.Access.pProcessData, smdev.u.Access.BytesToProcess); } while (0);
            if (smdev.u.Access.BytesToProcess > sizeof SBuffer)
            {
                pBAlloc = pBuffer = (PBYTE)kmalloc(smdev.u.Access.BytesToProcess, GFP_USER);
                if (!pBAlloc) return -EAGAIN;
            }
            copy_from_user(pBuffer, smdev.u.Access.pProcessData, smdev.u.Access.BytesToProcess);
            smdev.Success = (smbus_WriteDevice(smdev.DeviceHandle, smdev.u.Access.StartOffset, smdev.u.Access.BytesToProcess, pBuffer) == 0);
            copy_to_user((SMBUS_DEVICE_DATA *)arg, &smdev, sizeof(SMBUS_DEVICE_DATA));
            if (pBAlloc) kfree(pBAlloc);
            return 0;
        }
        case _IOR('s', 9, IOCTLDATA_INDEXED_PORT_IO):
        {
            IOCTLDATA_INDEXED_PORT_IO portio;
            copy_from_user(&portio, (IOCTLDATA_INDEXED_PORT_IO *)arg, sizeof(IOCTLDATA_INDEXED_PORT_IO));
            do { if (smbusDebug & (1 << (7))) printk(KERN_DEBUG "smbus :" "PORTIO index 0x%02x=0x%02x data 0x%02x\n",portio.IndexPort, portio.IndexData, portio.DataPort); } while (0);
            ReadFromIndexedPort(&portio);
            copy_to_user((IOCTLDATA_INDEXED_PORT_IO *)arg, &portio, sizeof(IOCTLDATA_INDEXED_PORT_IO));
            return 0;
        }
        case _IOW('s', 8, IOCTLDATA_INDEXED_PORT_IO):
        {
            IOCTLDATA_INDEXED_PORT_IO portio;
            copy_from_user(&portio, (IOCTLDATA_INDEXED_PORT_IO *)arg, sizeof(IOCTLDATA_INDEXED_PORT_IO));
            do { if (smbusDebug & (1 << (7))) printk(KERN_DEBUG "smbus :" "PORTIO index 0x%02x=0x%02x data 0x%02x=0x%02x\n",portio.IndexPort, portio.IndexData, portio.DataPort, portio.DataData); } while (0);
            WriteToIndexedPort(&portio);
            copy_to_user((IOCTLDATA_INDEXED_PORT_IO *)arg, &portio, sizeof(IOCTLDATA_INDEXED_PORT_IO));
            return 0;
        }
        case _IOR('s', 20, IOCTLDATA_GEN_IO):
        {
            IOCTLDATA_GEN_IO genio;
            copy_from_user(&genio, (IOCTLDATA_GEN_IO *)arg, sizeof(IOCTLDATA_GEN_IO));
            do { if (smbusDebug & (1 << (10))) printk(KERN_DEBUG "smbus :" "GENIO [%ld] of 0x%08lx\n",genio.DataWidth, genio.Address); } while (0);
            if (genio.Address >= (1 << (sizeof(unsigned short) * 8))) return -EINVAL;
            genio.WrRdData = 0L;
            switch(genio.DataWidth)
            {
            case sizeof(unsigned char):
                genio.WrRdData = (ulong)inb((unsigned short)genio.Address);
                break;
            case sizeof(unsigned short):
                genio.WrRdData = (ulong)inw((unsigned short)genio.Address);
                break;
            case sizeof(unsigned long):
                genio.WrRdData = (ulong)inl((unsigned short)genio.Address);
                break;
            default:
                return -EINVAL;
            }
            copy_to_user((IOCTLDATA_GEN_IO *)arg, &genio, sizeof(IOCTLDATA_GEN_IO));
            return 0;
        }
        case _IOW('s', 21, IOCTLDATA_GEN_IO):
        {
            IOCTLDATA_GEN_IO genio;
            copy_from_user(&genio, (IOCTLDATA_GEN_IO *)arg, sizeof(IOCTLDATA_GEN_IO));
            do { if (smbusDebug & (1 << (10))) printk(KERN_DEBUG "smbus :" "GENIO [%ld]0x%08lx to 0x%08lx\n",genio.DataWidth, genio.WrRdData, genio.Address); } while (0);
            if (genio.Address >= (1 << (sizeof(unsigned short) * 8))) return -EINVAL;
            switch(genio.DataWidth)
            {
            case sizeof(unsigned char):
                if (genio.WrRdData >= (1 << (sizeof(unsigned char) * 8))) return -EINVAL;
                outb((unsigned char)genio.WrRdData, (unsigned short)genio.Address);
                break;
            case sizeof(unsigned short):
                if (genio.WrRdData >= (1 << (sizeof(unsigned short) * 8))) return -EINVAL;
                outw((unsigned short)genio.WrRdData, (unsigned short)genio.Address);
                break;
            case sizeof(unsigned long):
                outl((unsigned long)genio.WrRdData, (unsigned short)genio.Address);
                break;
            default:
                return -EINVAL;
            }
            copy_to_user((IOCTLDATA_GEN_IO *)arg, &genio, sizeof(IOCTLDATA_GEN_IO));
            return 0;
        }
        case _IO('s', 23):
        {
            do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus :" "ScSmbusDevice IOCTL: Reset Master Device\n"); } while (0);
            if (!smbus_ResetSMBusCtrl())
                return -1;
        }
        case _IOR('s', 2, long):
            ulValue = CheckForIntrusionSupport();
            copy_to_user((unsigned long *)arg, &ulValue, sizeof(ULONG));
            do { if (smbusDebug & (1 << (8))) printk(KERN_DEBUG "smbus :" "INTRUSION support 0x%lx\n",ulValue); } while (0);
            return 0;
        case _IOR('s', 3, long):
            ulValue = CheckForCabinetIntrusion();
            copy_to_user((unsigned long *)arg, &ulValue, sizeof(ULONG));
            do { if (smbusDebug & (1 << (8))) printk(KERN_DEBUG "smbus :" "INTRUSION state %ld\n",ulValue); } while (0);
            return 0;
        case _IO('s', 4):
            if (m_pSmbiBase)
            {
                asus_PowerDown(ulASUSCmdBuffer, ulASUSResultBuffer, m_fSmbiExec);
            }
            else
            {
                smbus_PowerDown();
            }
            return -ENXIO;
        case _IOR('s', 7, long):
            ulValue = 0x00;
            if (m_pSmbiBase)
            {
                ulValue = 0x80;
            }
            else
            {
                (void)smbus_CheckHardwareType(&ulValue);
            }
            copy_to_user((unsigned long *)arg, &ulValue, sizeof(ULONG));
            return 0;
    }
    do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_ioctl: unsupported ioctl nr %d, size %d\n",_IOC_NR(cmd), _IOC_SIZE(cmd)); } while (0);
    return -EINVAL;
}
static void free_all(void)
{
    int i;
    if (pBAPIControlBuffer) kfree(pBAPIControlBuffer);
    pBAPIControlBuffer = NULL;
    if (pBAPIDataBuffer) kfree(pBAPIDataBuffer);
    pBAPIDataBuffer = NULL;
    if (pBAPIStaticPage)
    {
        mem_map_unreserve(virt_to_page(pBAPIStaticPage));
        free_page((ulong)pBAPIStaticPage);
    }
    pBAPIStaticPage = NULL;
    for (i = 0; i < 32; i++)
    {
        if (OpenDevices[i]) kfree(OpenDevices[i]);
        OpenDevices[i] = NULL;
    }
}
static struct file_operations smbus_fops =
{
    .ioctl = smbus_ioctl,
    .mmap = smbus_mmap,
    .open = smbus_open,
    .release = smbus_release
};
int init_module(void)
{
    do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus :" "init_module\n"); } while (0);
    if (!pci_present())
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "init_module: pcibios not present\n"); } while (0);
        return -ENODEV;
    }
    if (!isSMHardware())
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "init_module: SM Hardware not present\n"); } while (0);
        free_all();
        return -ENODEV;
    }
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "Found Hardware of Type 0x%x\n",(int)Chipset); } while (0);
    if((smbus_major = register_chrdev(smbus_major, SMBUS_DEV, &smbus_fops)) < 0)
    {
        printk(KERN_ERR "smbus: unable to get major %d\n", smbus_major);
        free_all();
        return -EIO;
    }
    return 0;
}
void cleanup_module(void)
{
    do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus :" "cleanup_module\n"); } while (0);
    free_all();
    if (unregister_chrdev(smbus_major, SMBUS_DEV) < 0)
    {
        printk(KERN_ERR "cop: unregister_chrdev(%i) failed!\n", smbus_major);
    }
}
#ident "$Header$"
#ident "$Header$"
#ident "$Header: $"
#ident "$Header$"
#ident "$Header: snismdrv.h 1.2 99/12/22 $"
#ident "$Header$"
static INT smbus_SwitchMux(DWORD DeviceHandle, PBYTE pDeviceAddress);
static BOOL smbus_ClearStatus(void);
static BOOL smbus_WaitHostBusy(void);
static BOOL smbus_WaitCmdDone(void);
static void smbus_ReleaseBus(void);
BOOL CtrlReset = 0;
DWORD smbus_ReadData(BYTE DeviceAddress, BYTE StartOffset, PBYTE pReturnBuffer, DWORD BytesToRead)
{
    DWORD ReturnDataSize = 0;
    BYTE Data = 0;
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_ReadData: read %d SM bus data bytes from %02X:%02X\n",BytesToRead, DeviceAddress, StartOffset); } while (0);
    if (Chipset == CS_UNKNOWN || 0 == BytesToRead || NULL == pReturnBuffer)
        return 0;
    if (smbus_ReadByte (DeviceAddress, StartOffset, &Data, 0))
    {
        PBYTE pData = (PBYTE)pReturnBuffer;
        DWORD Offset = StartOffset+1;
        *pData++ = Data;
        ReturnDataSize = 1;
        BytesToRead--;
        while (BytesToRead)
        {
            if (!(Offset < 256))
            {
                do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "## FATAL ERROR: smbus_ReadData: Offset exceeds 255 while reading data!\n"); } while (0);
                break;
            }
            if (!smbus_ReadByte (DeviceAddress, (BYTE)Offset, &Data, 1))
            {
                do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_ReadData: ERROR while reading data bytes, abort loop\n"); } while (0);
                break;
            }
            *pData++ = Data;
            Offset++;
            ReturnDataSize++;
            BytesToRead--;
        }
    }
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_ReadData: %d bytes read from SM bus\n",ReturnDataSize); } while (0);
    return ReturnDataSize;
}
DWORD smbus_WriteData(BYTE DeviceAddress, BYTE StartOffset, PBYTE pWriteData, DWORD BytesToWrite)
{
    DWORD WriteDataSize = 0;
    DWORD Offset = StartOffset;
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_WriteData: write %d SM bus data bytes to %02X:%02X...\n",BytesToWrite, DeviceAddress, StartOffset); } while (0);
    if (Chipset == CS_UNKNOWN || 0 == BytesToWrite || NULL == pWriteData)
        return WriteDataSize;
    while (BytesToWrite)
    {
        if (!(Offset < 256))
        {
            do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "## FATAL ERROR: smbus_WriteData: Offset exceeds 255 while writing data!\n"); } while (0);
            break;
        }
        if (smbus_WriteByte (DeviceAddress, (BYTE)Offset, *pWriteData, 0))
        {
            WriteDataSize++;
            BytesToWrite--;
            Offset++;
            pWriteData++;
        }
        else
        {
            do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_WriteData: ERROR while writing data bytes, abort loop\n"); } while (0);
            break;
        }
    }
    if (0 == BytesToWrite)
        do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_WriteData: %d bytes written to SM bus\n",WriteDataSize); } while (0);
    else
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "## ERROR: smbus_WriteData: Failed to write data byte 0x%02X:0x%02X!\n",DeviceAddress, Offset); } while (0);
    return WriteDataSize;
}
DWORD smbus_ReadOneByte(BYTE DeviceAddress, PBYTE pReturnByte)
{
    DWORD ReturnDataSize = 0;
    BYTE Data = 0;
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_ReadOneByte: read SM bus data byte from %02X\n",DeviceAddress); } while (0);
    if (Chipset == CS_UNKNOWN || NULL == pReturnByte)
        return 0;
    if(smbus_ReadByte(DeviceAddress,0,&Data,1))
    {
        *pReturnByte = Data;
        ReturnDataSize++;
    }
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_ReadOneByte: %d byte read from SM bus\n",ReturnDataSize); } while (0);
    return ReturnDataSize;
}
DWORD smbus_WriteOneByte(BYTE DeviceAddress, BYTE WriteData)
{
    DWORD WriteDataSize = 0;
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_WriteOneByte: write SM bus data bytes to %02X\n",DeviceAddress); } while (0);
    if (Chipset == CS_UNKNOWN)
        return 0;
    if (smbus_WriteByte (DeviceAddress, 0, WriteData, 1))
    {
        WriteDataSize++;
    }
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_WriteOneByte: %d byte written to SM bus\n",WriteDataSize); } while (0);
    return WriteDataSize;
}
INT smbus_OpenDevice(PDWORD pDeviceHandle, PVOID pDeviceAddressData, DWORD AddrTableSize)
{
    static spinlock_t smbus_handle_lock = SPIN_LOCK_UNLOCKED;
    DWORD Handle;
    INT Status = 0;
    BOOL Found = 0;
    if (!pDeviceHandle || !pDeviceAddressData) return 1;
    *pDeviceHandle = (DWORD)-1;
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus :" "smbus_OpenDevice: open device address 0x%02X...\n",((P_IOCTLDATA_SMBUS_OPEN_DEVICE)pDeviceAddressData)->DeviceAddress); } while (0);
    spin_lock(&smbus_handle_lock);
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus :" "smbus_OpenDevice: create new entry\n"); } while (0);
    for (Handle = 0; !Found && Handle < 32; Handle++)
    {
        if (OpenDevices[Handle] == NULL)
        {
            OpenDevices[Handle] = pDeviceAddressData;
            *pDeviceHandle = Handle;
            Found = 1;
            do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus :" "smbus_OpenDevice: new handle %04X assigned\n",*pDeviceHandle); } while (0);
        }
    }
    if (Handle >= 32)
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_OpenDevice: ## ERROR! OpenDevices table overflow!\n"); } while (0);
        Status = 3;
    }
    spin_unlock(&smbus_handle_lock);
    return Status;
}
INT smbus_CloseDevice(DWORD DeviceHandle)
{
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus :" "smbus_CloseDevice: close device handle %d\n",DeviceHandle); } while (0);
    if (DeviceHandle >= 32)
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_CloseDevice: ## ERROR! illegal device handle (%d)!\n",DeviceHandle); } while (0);
        return 2;
    }
    else if (!OpenDevices[DeviceHandle])
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_CloseDevice: ## ERROR! no device opened with handle %d!\n",DeviceHandle); } while (0);
        return 2;
    }
    else
    {
        kfree(OpenDevices[DeviceHandle]);
        OpenDevices[DeviceHandle] = NULL;
        return 0;
    }
}
INT smbus_ReadDevice(DWORD DeviceHandle, BYTE Offset, DWORD BytesToRead, PBYTE pReturnBuffer, PDWORD pBytesRead)
{
    INT Status = 0;
    BYTE DeviceAddress;
    *pBytesRead = 0;
    Status = smbus_SwitchMux (DeviceHandle, &DeviceAddress);
    if (0 == Status)
    {
        *pBytesRead = smbus_ReadData (DeviceAddress, Offset, pReturnBuffer, BytesToRead);
        if (0 == *pBytesRead)
            Status = 1;
    }
    return Status;
}
INT smbus_WriteDevice (DWORD DeviceHandle, BYTE Offset, DWORD BytesToWrite, PBYTE pWriteBuffer)
{
    INT Status = 0;
    BYTE DeviceAddress;
    Status = smbus_SwitchMux (DeviceHandle, &DeviceAddress);
    if (0 == Status)
    {
        DWORD BytesWritten = smbus_WriteData (DeviceAddress, Offset, pWriteBuffer, BytesToWrite);
        if (BytesToWrite != BytesWritten)
            Status = 1;
    }
    return Status;
}
BOOL smbus_ReadByte(BYTE DeviceAddress, BYTE Offset, PBYTE pData, BOOL NotUseOffset)
{
    BYTE ControlCmd;
    BOOL Success = 0;
    DWORD RetryCnt;
    if (!ulSMBusBaseAddress || !pData) return 0;
    ControlCmd = NotUseOffset ? ((BYTE)(1<<2)) : ((BYTE)(2<<2));
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_ReadByte: read data byte from 0x%02X:0x%02X%s\n",DeviceAddress, Offset, NotUseOffset ? " - without offset" : ""); } while (0);
    for (RetryCnt=0; !Success && RetryCnt < 3; RetryCnt++)
    {
        if (!smbus_WaitHostBusy())
        {
           do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "## ERROR: smbus_ReadByte: WaitHostBusy() failed!\n"); } while (0);
        }
        else if (!smbus_ClearStatus())
        {
           do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "## ERROR: smbus_ReadByte: ClearStatus() failed!\n"); } while (0);
        }
        else
        {
           do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_ReadByte: reading data byte...\n"); } while (0);
           outb_p(((DeviceAddress | ((BYTE)(1<<0)))), (int)(ulSMBusBaseAddress + (((BYTE)0x04))));
           if (!NotUseOffset)
               outb_p((Offset), (int)(ulSMBusBaseAddress + (((BYTE)0x03))));
           outb_p((ControlCmd | ((BYTE)(1<<6))), (int)(ulSMBusBaseAddress + (((BYTE)0x02))));
           Success = smbus_WaitCmdDone();
           if (Success)
           {
               *pData = inb_p((int)(ulSMBusBaseAddress + (((BYTE)0x05))));
               do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_ReadByte: data byte successfully read: 0x%02X!!\n",*pData); } while (0);
           }
           else
           {
               do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "## WARNING: smbus_ReadByte: WaitCmdDone() failed!\n"); } while (0);
               NotUseOffset = 0;
               if(0 != Offset)
                        ControlCmd = ((BYTE)(2<<2));
               do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "## RETRY\n"); } while (0);
           }
        }
    smbus_ReleaseBus();
    }
    return Success;
}
BOOL smbus_WriteByte(BYTE DeviceAddress, BYTE Offset, BYTE Data, BOOL NotUseOffset)
{
    BYTE ControlCmd;
    BOOL Success = 0;
    DWORD RetryCnt;
    if (!ulSMBusBaseAddress) return 0;
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_WriteByte: write data byte 0x%02X to 0x%02X:0x%02X%s\n",Data, DeviceAddress, Offset, NotUseOffset ? " - without offset" : ""); } while (0);
    ControlCmd = NotUseOffset ? ((BYTE)(1<<2)) : ((BYTE)(2<<2));
    for (RetryCnt = 0; !Success && RetryCnt < 3; RetryCnt++)
    {
        if (RetryCnt)
            do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "## WARNING: smbus_WriteByte: RETRY %d!!!\n",RetryCnt); } while (0);
        if (!smbus_WaitHostBusy())
        {
            do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "## ERROR: smbus_WriteByte: WaitHostBusy() failed!\n"); } while (0);
        }
        else if (!smbus_ClearStatus())
        {
            do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "## ERROR: smbus_WriteByte: ClearStatus() failed!\n"); } while (0);
        }
        else
        {
            do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_WriteByte: writing data byte...\n"); } while (0);
            outb_p(((DeviceAddress | ((BYTE)(0<<0)))), (int)(ulSMBusBaseAddress + (((BYTE)0x04))));
            if (!NotUseOffset)
            {
                do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_WriteByte: Set Offset %02x\n",Offset); } while (0);
                outb_p((Offset), (int)(ulSMBusBaseAddress + (((BYTE)0x03))));
            }
            else
            {
                do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_WriteByte: Set (data) %02x\n",Data); } while (0);
                outb_p((Data), (int)(ulSMBusBaseAddress + (((BYTE)0x03))));
            }
            do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_WriteByte: Set Data   %02x\n",Data); } while (0);
            outb_p((Data), (int)(ulSMBusBaseAddress + (((BYTE)0x05))));
            do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_WriteByte: Set Cmd    %02x\n",ControlCmd | ((BYTE)(1<<6))); } while (0);
            outb_p((ControlCmd | ((BYTE)(1<<6))), (int)(ulSMBusBaseAddress + (((BYTE)0x02))));
            do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_WriteByte: START sleep\n"); } while (0);
            set_current_state(TASK_UNINTERRUPTIBLE);
            schedule_timeout((10*HZ)/1000);
            do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_WriteByte: STOP  sleep\n"); } while (0);
            Success = smbus_WaitCmdDone();
            if (Success) do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "smbus_WriteByte: Data byte successfully written\n"); } while (0);
            smbus_ReleaseBus();
        }
    }
    if(!Success)
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "## ERROR: smbus_WriteByte: failed after retries!\n"); } while (0);
    }
    return Success;
}
INT smbus_SwitchMux(DWORD DeviceHandle, PBYTE pDeviceAddress)
{
    INT Status = 0;
    BOOL Abort = 0;
    DWORD i;
    P_IOCTLDATA_SMBUS_OPEN_DEVICE pAddr;
    if (DeviceHandle >= 32)
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_SwitchMux: ## ERROR! Illegal device handle (exceeds MAX_OPEN_DEVICES)!\n"); } while (0);
        Status = 2;
    }
    else if ((pAddr = (P_IOCTLDATA_SMBUS_OPEN_DEVICE)OpenDevices[DeviceHandle]) == NULL)
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_SwitchMux: ## ERROR! Illegal device handle (device not opened)!\n"); } while (0);
        Status = 2;
    }
    else
    {
        *pDeviceAddress = pAddr->DeviceAddress;
        do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus :" "smbus_SwitchMux: found DeviceAddress = 0x%02X\n",*pDeviceAddress); } while (0);
        for (i = 0; !Abort && (i < 32) && (i < pAddr->MuxesToProcess); i++)
        {
            P_SMBUS_MUX_ADDR pMuxAddr = &pAddr->pMuxAddr[i];
            do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus :" "                    MUX detected: Addr=0x%02X, Prot=%d, AndMask=0x%02X, OrMask=0x%02X\n",pMuxAddr->Address, pMuxAddr->Protocol,
                                                pMuxAddr->AndMask, pMuxAddr->OrMask); } while (0);
            switch (pMuxAddr->Protocol)
            {
            case 0:
                {
                    BYTE MuxByte;
                    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus :" "                    MUX protocol is \"WriteByte\"\n"); } while (0);
                    if (!smbus_ReadByte (pMuxAddr->Address, 0, &MuxByte, 1))
                        Abort = 1;
                    else
                    {
                        MuxByte = (MuxByte & pMuxAddr->AndMask) | pMuxAddr->OrMask;
                        if (!smbus_WriteByte (pMuxAddr->Address, 0, MuxByte, 1))
                            Abort = 1;
                    }
                    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus :" "smbus_SwitchMux: MUX at level %d (addr 0x%02X) switched\n",i+1, pMuxAddr->Address); } while (0);
                }
                break;
            default:
                do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_SwitchMux: ## FATAL ERROR: Unsupported MUX protocol (%d)\n",pMuxAddr->Protocol); } while (0);
                Abort = 1;
                break;
            }
        }
    }
    if (Abort)
        Status = 1;
    return Status;
}
BOOL smbus_ClearStatus(void)
{
    BYTE Status = inb_p((int)(ulSMBusBaseAddress + (((BYTE)0x00)))) & ~((BYTE)(1<<6));
    DWORD RetryCnt, WaitCnt;
    do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus :" "smbus_ClearStatus: Status = 0x%02X\n",Status); } while (0);
    Status &= ((((BYTE)(1<<2)) | ((BYTE)(1<<3)) | ((BYTE)(1<<4))) | ((BYTE)(1<<0)) | ((BYTE)(1<<1)));
    for (RetryCnt = 0; Status && (RetryCnt < 3); RetryCnt++)
    {
        if (RetryCnt)
            do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus :" "smbus_ClearStatus: ## WARNING: RETRY!!\n"); } while (0);
        for (WaitCnt = 0; Status && WaitCnt < 100; WaitCnt++)
        {
            do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus :" "smbus_ClearStatus: Status not zero, reset it...\n"); } while (0);
            outb_p(((((((BYTE)(1<<2)) | ((BYTE)(1<<3)) | ((BYTE)(1<<4))) | ((BYTE)(1<<0)) | ((BYTE)(1<<1))))), (int)(ulSMBusBaseAddress + (((BYTE)0x00))));
            udelay (10);
            Status = inb_p((int)(ulSMBusBaseAddress + (((BYTE)0x00))));
            do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus :" "smbus_ClearStatus: Status after reset = 0x%02X\n",Status); } while (0);
            Status &= ((((BYTE)(1<<2)) | ((BYTE)(1<<3)) | ((BYTE)(1<<4))) | ((BYTE)(1<<0)) | ((BYTE)(1<<1)));
            if (Status & ((BYTE)(1<<0)))
            {
                do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_ClearStatus: ## WARNING: BUSY while clearing status - send KILL command\n"); } while (0);
                outb_p((((BYTE)(1<<1))), (int)(ulSMBusBaseAddress + (((BYTE)0x02))));
                set_current_state(TASK_UNINTERRUPTIBLE);
                schedule_timeout((100*HZ)/1000);
                outb_p((0), (int)(ulSMBusBaseAddress + (((BYTE)0x02))));
                break;
            }
            if (Status)
            {
                set_current_state(TASK_UNINTERRUPTIBLE);
                schedule_timeout((1*HZ)/1000);
            }
        }
    }
    return (Status == 0);
}
BOOL smbus_WaitHostBusy(void)
{
    BYTE Status;
    DWORD i;
    BYTE StatusMask = (Chipset == CS_INTEL_ICH) ? (((BYTE)(1<<6)) | ((BYTE)(1<<0)))
                                                 : ((BYTE)(1<<0));
    for (i = 0; i < 35; i++)
    {
        Status = inb_p((int)(ulSMBusBaseAddress + (((BYTE)0x00))));
        if (Status & StatusMask)
        {
            set_current_state(TASK_UNINTERRUPTIBLE);
            schedule_timeout((1*HZ)/1000);
        }
        else
        {
            return 1;
        }
    }
    do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_WaitHostBusy: ## ERROR: Timeout while waiting host busy, status=0x%02X!\n",Status); } while (0);
    return 0;
}
BOOL smbus_WaitCmdDone(void)
{
    BOOL Done = 0;
    BOOL Success = 0;
    BYTE Status = 0;
    DWORD i;
    int k;
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "smbus_WaitCmdDone: waiting until command done...\n"); } while (0);
    for (i = 0; !Done && i < ((1000/50)*35); i++)
    {
        do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus :" "CSmbus::WaitCmdDone: sleep %d usec.\n",50); } while (0);
        udelay (50);
        Status = inb_p((int)(ulSMBusBaseAddress + (((BYTE)0x00))));
        do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus :" "smbus_WaitCmdDone: Status = 0x%02X, retry count = %d\n",Status, i); } while (0);
        if (Status & (((BYTE)(1<<1)) | ((BYTE)(1<<2)) | ((BYTE)(1<<3)) | ((BYTE)(1<<4))))
        {
            Done = 1;
            if (!(Status & (((BYTE)(1<<2)) | ((BYTE)(1<<3)) | ((BYTE)(1<<4)))))
                Success = 1;
            else
            {
                LPSTR pErrMsg;
                if (Status & ((BYTE)(1<<2)))
                    pErrMsg = "device error";
                else if (Status & ((BYTE)(1<<3)))
                    pErrMsg = "bus error";
                else if (Status & ((BYTE)(1<<4)))
                    pErrMsg = "kill";
                else
                {
                    pErrMsg = "## Unknown error ##";
                }
                do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_WaitCmdDone: SM BUS ERROR <<%s>>, status=0x%02X!\n",pErrMsg, Status); } while (0);
                for (k=0;k<50;k++)
                {
                        if(Status & ((BYTE)(1<<0)))
                        {
                                Status = inb_p((int)(ulSMBusBaseAddress + (((BYTE)0x00))));
                                do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus :" "CSmbus::WaitCmdDone: wait for Status not busy (%d 0x%02X)\n",k,Status); } while (0);
                                udelay (5);
                        }
                        else break;
                }
            }
        }
    }
    if (!Done)
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_WaitHostBusy: ## ERROR: timeout while waiting for transaction done (status=0x%02X)!\n",Status); } while (0);
        CtrlReset = smbus_ResetSMBusCtrl();
    }
    return Success;
}
void smbus_ReleaseBus(void)
{
    if(CS_INTEL_ICH == Chipset)
    {
       outb_p((((BYTE)(1<<6))), (int)(ulSMBusBaseAddress + (((BYTE)0x00))));
       do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus :" "\nCSmbus::ReleaseBus: Release ICH Semaphore"); } while (0);
    }
}
BOOL smbus_CheckHardwareType(PULONG pulType)
{
    UCHAR ucDeviceId1 = 0;
    UCHAR ucDeviceId2 = 0;
    UCHAR ucDeviceId3 = 0;
    UCHAR ucRevision = 0;
    unsigned char bSuccess = 0;
    *pulType = 0x00;
    bSuccess = smbus_ReadByte(0xE6, 0x00, &ucDeviceId1, 0);
    if (!bSuccess)
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_CheckHardwareType : SMBus Read Operation failed!!\n"); } while (0);
        return 0;
    }
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "smbus_CheckHardwareType : Device ID 1 = 0x%X\n",ucDeviceId1); } while (0);
    bSuccess = smbus_ReadByte(0xE6, 0x01, &ucDeviceId2, 0);
    if (!bSuccess)
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_CheckHardwareType : SMBus Read Operation failed!!!\n"); } while (0);
        return 0;
    }
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "smbus_CheckHardwareType : Device ID 2 = 0x%X\n",ucDeviceId2); } while (0);
    bSuccess = smbus_ReadByte(0xE6, 0x02, &ucDeviceId3, 0);
    if (!bSuccess)
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_CheckHardwareType : SMBus Read Operation failed!!!!\n"); } while (0);
        return 0;
    }
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "smbus_CheckHardwareType : Device ID 3 = 0x%X\n",ucDeviceId3); } while (0);
    bSuccess = smbus_ReadByte(0xE6, 0x03, &ucRevision, 0);
    if (!bSuccess)
    {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_CheckHardwareType : SMBus Read Operation failed!!!!\n"); } while (0);
        return 0;
    }
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "smbus_CheckHardwareType : Revision ID = 0x%X\n",ucRevision); } while (0);
    if ((ucDeviceId1 == 'S') &&
        (ucDeviceId2 == 'C') &&
        (ucDeviceId3 == 'Y'))
    {
        *pulType = 0x200;
        return 1;
    }
    if ((ucDeviceId1 == 'H') &&
        (ucDeviceId2 == 'Y') &&
        (ucDeviceId3 == 'D'))
    {
        *pulType = 0x40;
        return 1;
    }
    if ((ucDeviceId1 == 'P') &&
        (ucDeviceId2 == 'O') &&
        (ucDeviceId3 == 'S'))
    {
        *pulType = 0x20;
        return 1;
    }
    if ((ucDeviceId1 == 'P') &&
        (ucDeviceId2 == 'E') &&
        (ucDeviceId3 == 'G'))
    {
        if ( ucRevision >= 0x10 )
            *pulType = 0x10 | 0x08;
        else
            *pulType = 0x08;
        return 1;
    }
    if ((ucDeviceId1 == 'N') &&
        (ucDeviceId2 == 'T') &&
        (ucDeviceId3 == 'L'))
    {
        *pulType = 0x04;
        return 1;
    }
    return 0;
}
void smbus_PowerDown(void)
{
    BYTE ucMagic;
    ucMagic = *((BYTE *)phys_to_virt(0x00000416));
    if (ucMagic & 0x80)
    {
        do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "smbus_PowerDown : Bios Shutdown, magic 0x%02x\n",ucMagic); } while (0);
        *((BYTE *)phys_to_virt(0x00000416)) = ucMagic & 0x7f;
        *((WORD *)phys_to_virt(0x00000472)) = 0x1234;
        CMOS_WRITE(0x00, 0x0f);
        outb_p(0xfe, KBD_CNTL_REG);
    }
    do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "smbus_PowerDown : Shutdown failed\n"); } while (0);
}
void asus_PowerDown(char *CmdBuffer, char *ResultBuffer, SMBI_CMD_ROUTINE fSmbiExec)
{
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus :" "asus_PowerDown(%p,%p,%p)\n",CmdBuffer, ResultBuffer, fSmbiExec); } while (0);
    *CmdBuffer = 0x03;
    CmdBuffer++;
    *CmdBuffer = 0x01;
    asm("pushl %edx");
    asm("pushl %eax");
    (*fSmbiExec)();
    asm("popl %eax");
    asm("popl %edx");
    do { if (smbusDebug) printk(KERN_DEBUG "smbus :" "asus_PowerDown : Shutdown failed (result: 0x%x)\n",(int)*ResultBuffer); } while (0);
}